--[[ MMT: The Debugger
	- This portion of the script is seperate from the other, mainly so debugging stuff can be more easily handled.
	
TODO:
	- [ ] Revamp everything, if a variable is "nil", "false", or "0" (should be detectable by *not*), don't show it, and decrement a counter used for mutliplcation stuff by 1 (or increment it if subtracting from it.
	- [ ] Add a new page 3, shift everything over by one. Make this the second part to the player.var stuff.
	- [ ] Investigate devmode command, replicate anything missing in here. It goes up to 9.
	- [ ] New debug screen: flags, flags2, eflags.
	- [ ] Fix this erroring out in massive amounts when the player is in the game over state.

	- [ ] Include /FRACUNIT stuff for things that would be best viewed in fracunits. It should be in parenthesis next to it.
	- [ ] If in MMT, detect for button press set via the menu.
	
	- [ ] Implement SPR2/sprite2 checks; someone in the discord wrote up what all of them are.
]]


-- List of all known states in v2.2 was dug out from p_mobj.c and dehacked.c becuz it's not all on the SRB2 wiki yet.

--[[if mmtVersion
	local function mmtversionstuff(v)
		if mmtIndev and player.MMT.mmtHudValue != "disablehud"
			if mmtdebuggervar == "on"
			v.drawString(5, 5, ("\x83\MMT \x89" .. mmtVersion .. "\x80\,\x85 Debugger On"), V_ALLOWLOWERCASE|V_TRANSLUCENT|V_NOSCALESTART, "thin")
			else
			v.drawString(5, 5, ("\x83\MMT \x89" .. mmtVersion .. "\x80\,\x83 Debugger Off"), V_ALLOWLOWERCASE|V_TRANSLUCENT|V_NOSCALESTART, "thin")
			end
		elseif mmtdebuggervar == "on" and player.MMT.mmtHudValue != "disablehud"
			v.drawString(5, 5, ("\x83\MMT \x89" .. mmtVersion .. "\x80\,\x85 Debugger On"), V_ALLOWLOWERCASE|V_TRANSLUCENT|V_NOSCALESTART, "thin")
		end
	end

	hud.add(mmtversionstuff)
	hud.add(mmtversionstuff, "title")
else
	rawset(_G, "player.MMT.mmtTheHudStuff", 0)
	rawset(_G, "player.MMT.mmtHudValue", "enablehud")
	print("*\x82 mmt.lua not detected\x80, running debug script as standalone")
end]]

addHook("MobjThinker", function(mobj) local player = mobj.player
	if not player.MMT.mmtTheHudStuff
		player.MMT.mmtTheHudStuff = 0
		player.MMT.mmtHudValue = 0
	end
	
	-- [ Personal Debugging Tools ] --
	if player.MMT.MMTdebughud != nil and player.MMT.MMTdebughud != "off" 
		if player.MMTbt[MMT_KeyToAmp(player.MMT.MMTdebughud)] == 1
			local HudStuffMax = 6 + 1
			player.MMT.mmtTheHudStuff = $ + 1
			if player.MMT.mmtTheHudStuff == HudStuffMax
				player.MMT.mmtTheHudStuff = 0
			end
		end
		--if player.cmd.buttons & BT_CUSTOM1 and player.MMT.mmtTheHudStuff > 0
		--	print((player.mo.z - player.mo.floorz)/FRACUNIT)
		--	print(player.mo.z - player.mo.floorz)
		--end
	end
end, MT_PLAYER)

local function DEBUGHUD(v, player, camera)
	if v.dupy() == 1 -- lowest resolution
		v.YOffset = 4
		v.InitialY = 10
	elseif v.dupy() == 2 -- above lowest
		v.YOffset = 8
		v.InitialY = 10
	elseif v.dupy() == 3 -- 720p+
		v.YOffset = 15
		v.InitialY = 10
	elseif v.dupy() == 4 -- ??? seems to work with 1080p numbers
		v.YOffset = 20
		v.InitialY = 15
	elseif  v.dupy() == 5 -- 1080p?
		v.YOffset = 20
		v.InitialY = 15
	end
if not mmtVersion
	v.InitialY = $ - 12
end

if player.MMT.mmtHudValue != "disablehud"
	if player.MMT.mmtTheHudStuff == 1
		hud.disable("score")
		hud.disable("rings")
		hud.disable("time")
		v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8D\PF_FLIPCAM: \x80" .. (player.pflags & PF_FLIPCAM)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8D\PF_ANALOGMODE: \x80" .. (player.pflags & PF_ANALOGMODE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8D\PF_DIRECTIONCHAR: \x80" .. (player.pflags & PF_DIRECTIONCHAR)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8D\PF_AUTOBRAKE: \x80" .. (player.pflags & PF_AUTOBRAKE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8D\PF_GODMODE: \x80" .. (player.pflags & PF_GODMODE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\PF_NOCLIP: \x80" .. (player.pflags & PF_NOCLIP)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8D\PF_INVIS: \x80" .. (player.pflags & PF_INVIS)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8D\PF_ATTACKDOWN: \x80" .. (player.pflags & PF_ATTACKDOWN)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8D\PF_USEDOWN: \x80" .. (player.pflags & PF_USEDOWN)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8D\PF_JUMPDOWN: \x80" .. (player.pflags & PF_JUMPDOWN)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8D\PF_WPNDOWN: \x80" .. (player.pflags & PF_WPNDOWN)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\PF_STASIS: \x80" .. (player.pflags & PF_STASIS)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8D\PF_JUMPSTASIS: \x80" .. (player.pflags & PF_JUMPSTASIS)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8D\PF_FULLSTASIS: \x80" .. (player.pflags & PF_FULLSTASIS)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8D\PF_APPLYAUTOBRAKE: \x80" .. (player.pflags & PF_APPLYAUTOBRAKE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8D\PF_STARTJUMP: \x80" .. (player.pflags & PF_STARTJUMP)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8D\PF_JUMPED: \x80" .. (player.pflags & PF_JUMPED)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\PF_NOJUMPDAMAGE: \x80" .. (player.pflags & PF_NOJUMPDAMAGE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8D\PF_SPINNING: \x80" .. (player.pflags & PF_SPINNING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8D\PF_STARTDASH: \x80" .. (player.pflags & PF_STARTDASH)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8D\PF_THOKKED: \x80" .. (player.pflags & PF_THOKKED)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8D\PF_SHIELDABILITY: \x80" .. (player.pflags & PF_SHIELDABILITY)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8D\PF_GLIDING: \x80" .. (player.pflags & PF_GLIDING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*24)), ("\x8D\PF_BOUNCING: \x80" .. (player.pflags & PF_BOUNCING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*25)), ("\x8D\PF_SLIDING: \x80" .. (player.pflags & PF_SLIDING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*26)), ("\x8D\PF_TRANSFERTOCLOSEST: \x80" .. (player.pflags & PF_TRANSFERTOCLOSEST)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*27)), ("\x8D\PF_DRILLING: \x80" .. (player.pflags & PF_DRILLING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*28)), ("\x8D\PF_GAMETYPEOVER: \x80" .. (player.pflags & PF_GAMETYPEOVER)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*29)), ("\x8D\PF_TAGIT: \x80" .. (player.pflags & PF_TAGIT)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*30)), ("\x8D\PF_FORCESTRAFE: \x80" .. (player.pflags & PF_FORCESTRAFE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*31)), ("\x8D\PF_CANCARRY: \x80" .. (player.pflags & PF_CANCARRY)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*32)), ("\x8D\PF_FINISHED: \x80" .. (player.pflags & PF_FINISHED)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		v.drawString(5, (v.InitialY+(v.YOffset*33)), ("\x8D\player.pflag: \x80" .. player.pflags), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
	elseif player.MMT.mmtTheHudStuff == 2
			if player.mo.state == S_PLAY_STND
				v.playermostatevar = "S_PLAY_STND"
			elseif player.mo.state == S_PLAY_WAIT
				v.playermostatevar = "S_PLAY_WAIT"
			elseif player.mo.state == S_PLAY_NIGHTS_STAND
				v.playermostatevar = "S_PLAY_NIGHTS_STAND"
			elseif player.mo.state == S_PLAY_EDGE
				v.playermostatevar = "S_PLAY_EDGE"
			elseif player.mo.state == S_PLAY_WALK
				v.playermostatevar = "S_PLAY_WALK"
			elseif player.mo.state == S_PLAY_SKID
				v.playermostatevar = "S_PLAY_SKID"
			elseif player.mo.state == S_PLAY_FLOAT
				v.playermostatevar = "S_PLAY_FLOAT"
			elseif player.mo.state == S_PLAY_RUN
				v.playermostatevar = "S_PLAY_RUN"
			elseif player.mo.state == S_PLAY_FLOAT_RUN
				v.playermostatevar = "S_PLAY_FLOAT_RUN"
			elseif player.mo.state == S_PLAY_DASH
				v.playermostatevar = "S_PLAY_DASH"
			elseif player.mo.state == S_PLAY_PAIN
				v.playermostatevar = "S_PLAY_PAIN"
			elseif player.mo.state == S_PLAY_STUN
				v.playermostatevar = "S_PLAY_STUN"
			elseif player.mo.state == S_PLAY_ROLL
				v.playermostatevar = "S_PLAY_ROLL"
			elseif player.mo.state == S_PLAY_NIGHTS_ATTACK
				v.playermostatevar = "S_PLAY_NIGHTS_ATTACK"
			elseif player.mo.state == S_PLAY_JUMP
				v.playermostatevar = "S_PLAY_JUMP"
			elseif player.mo.state == S_PLAY_SPRING
				v.playermostatevar = "S_PLAY_SPRING"
			elseif player.mo.state == S_PLAY_FALL
				v.playermostatevar = "S_PLAY_FALL"
			elseif player.mo.state == S_PLAY_NIGHTS_FLOAT
				v.playermostatevar = "S_PLAY_NIGHTS_FLOAT"
			elseif player.mo.state == S_PLAY_FLY
				v.playermostatevar = "S_PLAY_FLY"
			elseif player.mo.state == S_PLAY_FLY_TIRED
				v.playermostatevar = "S_PLAY_FLY_TIRED"
			elseif player.mo.state == S_PLAY_SWIM
				v.playermostatevar = "S_PLAY_SWIM"
			elseif player.mo.state == S_PLAY_GLIDE
				v.playermostatevar = "S_PLAY_GLIDE"
			elseif player.mo.state == S_PLAY_BOUNCE
				v.playermostatevar = "S_PLAY_BOUNCE"
			elseif player.mo.state == S_PLAY_BOUNCE_LANDING
				v.playermostatevar = "S_PLAY_BOUNCE_LANDING"
			elseif player.mo.state == S_PLAY_TWINSPIN
				v.playermostatevar = "S_PLAY_TWINSPIN"
			elseif player.mo.state == S_PLAY_SPINDASH
				v.playermostatevar = "S_PLAY_SPINDASH"
			elseif player.mo.state == S_PLAY_FIRE
				v.playermostatevar = "S_PLAY_FIRE"
			elseif player.mo.state == S_PLAY_FIRE_FINISH
				v.playermostatevar = "S_PLAY_FIRE_FINISH"
			elseif player.mo.state == S_PLAY_MELEE
				v.playermostatevar = "S_PLAY_MELEE"
			elseif player.mo.state == S_PLAY_MELEE_FINISH
				v.playermostatevar = "S_PLAY_MELEE_FINISH"
			elseif player.mo.state == S_PLAY_MELEE_LANDING
				v.playermostatevar = "S_PLAY_MELEE_LANDING"
			elseif player.mo.state == S_PLAY_RIDE
				v.playermostatevar = "S_PLAY_RIDE"

			elseif player.mo.state == S_PLAY_SUPER_TRANS1 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS1"
			elseif player.mo.state == S_PLAY_SUPER_TRANS2 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS2"
			elseif player.mo.state == S_PLAY_SUPER_TRANS3 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS3"
			elseif player.mo.state == S_PLAY_SUPER_TRANS4 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS4"
			elseif player.mo.state == S_PLAY_SUPER_TRANS5 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS5"
			elseif player.mo.state == S_PLAY_SUPER_TRANS6 -- trans rights!
				v.playermostatevar = "S_PLAY_SUPER_TRANS6"
			elseif player.mo.state == S_OBJPLACE_DUMMY
				v.playermostatevar = "S_OBJPLACE_DUMMY"
			elseif player.mo.state == S_PLAY_NIGHTS_FLY
				v.playermostatevar = "S_PLAY_NIGHTS_FLY"
			elseif player.mo.state == S_PLAY_NIGHTS_DRILL
				v.playermostatevar = "S_PLAY_NIGHTS_DRILL"
			elseif player.mo.state == S_PLAY_NIGHTS_STUN
				v.playermostatevar = "S_PLAY_NIGHTS_STUN"
			elseif player.mo.state == S_PLAY_NIGHTS_PULL
				v.playermostatevar = "S_PLAY_NIGHTS_PULL"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS1 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS1"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS2 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS2"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS3 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS3"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS4 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS4"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS5 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS5"
			elseif player.mo.state == S_PLAY_NIGHTS_TRANS6 -- trans rights!
				v.playermostatevar = "S_PLAY_NIGHTS_TRANS6"
			elseif player.mo.state == S_PLAY_GLIDE
				v.playermostatevar = "S_PLAY_GLIDE"
			elseif player.mo.state == S_PLAY_GLIDE_LANDING
				v.playermostatevar = "S_PLAY_GLIDE_LANDING"
			elseif player.mo.state == S_PLAY_CLING
				v.playermostatevar = "S_PLAY_CLING"
			elseif player.mo.state == S_PLAY_CLIMB
				v.playermostatevar = "S_PLAY_CLIMB"
			elseif player.mo.state == S_PLAY_DEAD
				v.playermostatevar = "S_PLAY_DEAD"
			elseif player.mo.state == S_PLAY_DRWN
				v.playermostatevar = "S_PLAY_DRWN"
			elseif player.mo.state == S_PLAY_GASP
				v.playermostatevar = "S_PLAY_GASP"
			else
				v.playermostatevar = "\x85 UNKNOWN?"
			end
			
			if player.playerstate == PST_LIVE
				v.playerplayerstatevar = "PST_LIVE"
			elseif player.playerstate == PST_DEAD
				v.playerplayerstatevar = "PST_DEAD"
			elseif player.playerstate == PST_REBORN
				v.playerplayerstatevar = "PST_REBORN"
			else
				v.playerplayerstatevar = "\x85 UNKNOWN?"
			end
			
			if player.panim == PA_ETC
				v.playerpanimvar = "PA_ETC"
			elseif player.panim == PA_IDLE
				v.playerpanimvar = "PA_IDLE"
			elseif player.panim == PA_EDGE
				v.playerpanimvar = "PA_EDGE"
			elseif player.panim == PA_WALK
				v.playerpanimvar = "PA_WALK"
			elseif player.panim == PA_RUN
				v.playerpanimvar = "PA_RUN"
			elseif player.panim == PA_DASH
				v.playerpanimvar = "PA_DASH"
			elseif player.panim == PA_PAIN
				v.playerpanimvar = "PA_PAIN"
			elseif player.panim == PA_ROLL
				v.playerpanimvar = "PA_ROLL"
			elseif player.panim == PA_JUMP
				v.playerpanimvar = "PA_JUMP"
			elseif player.panim == PA_SPRING
				v.playerpanimvar = "PA_SPRING"
			elseif player.panim == PA_FALL
				v.playerpanimvar = "PA_FALL"
			elseif player.panim == PA_ABILITY
				v.playerpanimvar = "PA_ABILITY"
			elseif player.panim == PA_ABILITY2
				v.playerpanimvar = "PA_ABILITY2"
			elseif player.panim == PA_RIDE
				v.playerpanimvar = "PA_RIDE"
			else
				v.playerpanimvar = "\x85 UNKNOWN?"
			end
			
			if player.charability == CA_NONE
				v.playercharabilityvar = "CA_NONE"
			elseif player.charability == CA_THOK
				v.playercharabilityvar = "CA_THOK"
			elseif player.charability == CA_FLY
				v.playercharabilityvar = "CA_FLY"
			elseif player.charability == CA_GLIDEANDCLIMB
				v.playercharabilityvar = "CA_GLIDEANDCLIMB"
			elseif player.charability == CA_HOMINGTHOK
				v.playercharabilityvar = "CA_HOMINGTHOK"
			elseif player.charability == CA_SWIM
				v.playercharabilityvar = "CA_SWIM"
			elseif player.charability == CA_DOUBLEJUMP
				v.playercharabilityvar = "CA_DOUBLEJUMP"
			elseif player.charability == CA_FLOAT
				v.playercharabilityvar = "CA_FLOAT"
			elseif player.charability == CA_SLOWFALL
				v.playercharabilityvar = "CA_SLOWFALL"
			elseif player.charability == CA_TELEKINESIS
				v.playercharabilityvar = "CA_TELEKINESIS"
			elseif player.charability == CA_FALLSWITCH
				v.playercharabilityvar = "CA_FALLSWITCH"
			elseif player.charability == CA_JUMPBOOST
				v.playercharabilityvar = "CA_JUMPBOOST"
			elseif player.charability == CA_AIRDRILL
				v.playercharabilityvar = "CA_AIRDRILL"
			elseif player.charability == CA_JUMPTHOK
				v.playercharabilityvar = "CA_JUMPTHOK"
			elseif player.charability == CA_BOUNCE
				v.playercharabilityvar = "CA_BOUNCE"
			elseif player.charability == CA_TWINSPIN
				v.playercharabilityvar = "CA_TWINSPIN"
			else
				v.playercharabilityvar = "\x85 UNKNOWN?"
			end

			if player.charability2 == CA2_NONE
				v.playercharability2var = "CA2_NONE"
			elseif player.charability2 == CA2_SPINDASH
				v.playercharability2var = "CA2_SPINDASH"
			elseif player.charability2 == CA2_GUNSLINGER
				v.playercharability2var = "CA2_GUNSLINGER"
			elseif player.charability2 == CA2_MELEE
				v.playercharability2var = "CA2_MELEE"
			else
				v.playercharability2var = "\x85 UNKNOWN?"
			end
			
			v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8D\player.playerstate: \x80" .. v.playerplayerstatevar .. "\x80 (\x82" .. player.playerstate .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8D\player.mo.state: \x80" .. v.playermostatevar .. "\x80 (\x82" .. player.mo.state .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8D\player.panim: \x80" .. v.playerpanimvar .. "\x80 (\x82" .. player.panim .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8D\player.charability: \x80" .. v.playercharabilityvar .. "\x80 (\x82" .. player.charability .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8D\player.charability2: \x80" .. v.playercharability2var .. "\x80 (\x82" .. player.charability2 .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\player.mo.momx: \x80" .. tostring(player.mo.momx) .. " " .. "(\x82" .. tostring(player.mo.momx/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8D\player.mo.momy: \x80" .. tostring(player.mo.momy) .. " " .. "(\x82" .. tostring(player.mo.momy/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8D\player.mo.momz: \x80" .. tostring(player.mo.momz) .. " " .. "(\x82" .. tostring(player.mo.momz/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")			
			v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8D\player.mo.x: \x80" .. tostring(player.mo.x) .. " " .. "(\x82" .. tostring(player.mo.x/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8D\player.mo.y: \x80" .. tostring(player.mo.y) .. " " .. "(\x82" .. tostring(player.mo.y/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8D\player.mo.z: \x80" .. tostring(player.mo.z) .. " " .. "(\x82" .. tostring(player.mo.z/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\player.speed: \x80" .. tostring(player.speed) .. " " .. "(\x82" .. tostring(player.speed/FRACUNIT) .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8D\player.pity: \x80" .. tostring(player.pity)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8D\player.flashcount: \x80" .. tostring(player.flashcount)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8D\player.flashpal: \x80" .. tostring(player.flashpal)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8D\player.skincolor: \x80" .. tostring(player.skincolor)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8D\player.mo.color: \x80" .. tostring(player.mo.color)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\player.dashspeed: \x80" .. tostring(player.dashspeed)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8D\player.dashtime: \x80" .. tostring(player.dashtime)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8D\player.continues: \x80" .. tostring(player.continues)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8D\player.secondjump: \x80" .. tostring(player.secondjump)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8D\player.fly1: \x80" .. tostring(player.fly1)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8D\player.scoreadd: \x80" .. tostring(player.scoreadd)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*24)), ("\x8D\player.glidetime: \x80" .. tostring(player.glidetime)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*25)), ("\x8D\player.climbing: \x80" .. tostring(player.climbing)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*26)), ("\x8D\player.homing: \x80" .. tostring(player.homing)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*27)), ("\x8D\player.numboxes: \x80" .. tostring(player.numboxes)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*28)), ("\x8D\player.totalring: \x80" .. tostring(player.totalring)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*29)), ("\x8D\player.exiting: \x80" .. tostring(player.exiting)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*30)), ("\x8D\player.losstime: \x80" .. tostring(player.losstime)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*31)), ("\x8D\player.aiming: \x80" .. tostring(player.aiming)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		elseif player.MMT.mmtTheHudStuff == 3
			v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8D\skin name: \x80" .. tostring(skins[player.mo.skin].name)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8D\skin: \x80" .. tostring(skins[player.mo.skin].name)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8D\SF_SUPER: \x80" .. tostring(player.charflags & SF_SUPER) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_SUPER .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8D\SF_NOSUPERSPIN: \x80" .. tostring(player.charflags & SF_NOSUPERSPIN) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSUPERSPIN .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8D\SF_NOSPINDASHDUST: \x80" .. tostring(player.charflags & SF_NOSPINDASHDUST) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSPINDASHDUST .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\SF_HIRES: \x80" .. tostring(player.charflags & SF_HIRES) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_HIRES .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8D\SF_NOSKID: \x80" .. tostring(player.charflags & SF_NOSKID) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSKID .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8D\SF_NOSPEEDADJUST: \x80" .. tostring(player.charflags & SF_NOSPEEDADJUST) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSPEEDADJUST .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8D\SF_RUNONWATER: \x80" .. tostring(player.charflags & SF_RUNONWATER) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_RUNONWATER .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8D\SF_NOJUMPSPIN: \x80" .. tostring(player.charflags & SF_NOJUMPSPIN) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOJUMPSPIN .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8D\SF_NOJUMPDAMAGE: \x80" .. tostring(player.charflags & SF_NOJUMPDAMAGE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOJUMPDAMAGE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\SF_STOMPDAMAGE: \x80" .. tostring(player.charflags & SF_STOMPDAMAGE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_STOMPDAMAGE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8D\SF_MARIODAMAGE: \x80" .. tostring(player.charflags & SF_MARIODAMAGE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_MARIODAMAGE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8D\SF_MACHINE: \x80" .. tostring(player.charflags & SF_MACHINE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_MACHINE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8D\SF_DASHMODE: \x80" .. tostring(player.charflags & SF_DASHMODE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_DASHMODE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8D\SF_FASTEDGE: \x80" .. tostring(player.charflags & SF_FASTEDGE) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_FASTEDGE .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8D\SF_MULTIABILITY: \x80" .. tostring(player.charflags & SF_MULTIABILITY) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_MULTIABILITY .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\SF_NONIGHTSROTATION: \x80" .. tostring(player.charflags & SF_NONIGHTSROTATION) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NONIGHTSROTATION .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8D\SF_NONIGHTSSUPER: \x80" .. tostring(player.charflags & SF_NONIGHTSSUPER) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NONIGHTSSUPER .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8D\SF_NOSUPERSPRITES: \x80" .. tostring(player.charflags & SF_NOSUPERSPRITES) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSUPERSPRITES .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8D\SF_NOSUPERJUMPBOOST: \x80" .. tostring(player.charflags & SF_NOSUPERJUMPBOOST) .. "\x80 (\x82" .. skins[player.mo.skin].flags & SF_NOSUPERJUMPBOOST .. "\x80)" ), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8D\player.charflags: \x80" .. tostring(player.charflags)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8D\skins[player.mo.skin].flags: \x80" .. tostring(skins[player.mo.skin].flags)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		elseif player.MMT.mmtTheHudStuff == 4
			if player.powers[pw_shield] == SH_NONE -- TODO: ADD SPECIAL CHECKS FOR FORCE/FORCEHP
				v.pwshieldvar = "SH_NONE"
			elseif player.powers[pw_shield] == SH_PITY
				v.pwshieldvar = "SH_PITY"
			elseif player.powers[pw_shield] == SH_WHIRLWIND
				v.pwshieldvar = "SH_WHIRLWIND"
			elseif player.powers[pw_shield] == SH_ARMAGEDDON
				v.pwshieldvar = "SH_ARMAGEDDON"
			elseif player.powers[pw_shield] == SH_PINK
				v.pwshieldvar = "SH_PINK"
			elseif player.powers[pw_shield] == SH_ELEMENTAL
				v.pwshieldvar = "SH_ELEMENTAL"
			elseif player.powers[pw_shield] == SH_ATTRACT
				v.pwshieldvar = "SH_ATTRACT"
			elseif player.powers[pw_shield] == SH_FLAMEAURA
				v.pwshieldvar = "SH_FLAMEAURA"
			elseif player.powers[pw_shield] == SH_BUBBLEWRAP
				v.pwshieldvar = "SH_BUBBLEWRAP"
			elseif player.powers[pw_shield] == SH_THUNDERCOIN
				v.pwshieldvar = "SH_THUNDERCOIN"
			elseif player.powers[pw_shield] == SH_FIREFLOWER
				v.pwshieldvar = "SH_FIREFLOWER"
			elseif player.powers[pw_shield] == SH_FORCE
				v.pwshieldvar = "SH_FORCE"
			elseif player.powers[pw_shield] & SH_FORCEHP
				v.pwshieldvar = "& SH_FORCEHP"
			else 
				v.pwshieldvar = "\x85 UNKNOWN?"
			end
			if player.powers[pw_carry] == CR_NONE -- TODO: ADD SPECIAL CHECKS FOR FORCE/FORCEHP
				v.pwcarryvar = "CR_NONE"
			elseif player.powers[pw_carry] == CR_GENERIC
				v.pwcarryvar = "CR_GENERIC"
			elseif player.powers[pw_carry] == CR_PLAYER
				v.pwcarryvar = "CR_PLAYER"
			elseif player.powers[pw_carry] == CR_NIGHTSMODE
				v.pwcarryvar = "CR_NIGHTSMODE"
			elseif player.powers[pw_carry] == CR_NIGHTSFALL
				v.pwcarryvar = "CR_NIGHTSFALL"
			elseif player.powers[pw_carry] == CR_BRAKGOOP
				v.pwcarryvar = "CR_BRAKGOOP"
			elseif player.powers[pw_carry] == CR_ZOOMTUBE
				v.pwcarryvar = "CR_ZOOMTUBE"
			elseif player.powers[pw_carry] == CR_ROPEHANG
				v.pwcarryvar = "CR_ROPEHANG"
			elseif player.powers[pw_carry] == CR_MACESPIN
				v.pwcarryvar = "CR_MACESPIN"
			elseif player.powers[pw_carry] == CR_MINECART
				v.pwcarryvar = "CR_MINECART"
			elseif player.powers[pw_carry] == CR_ROLLOUT
				v.pwcarryvar = "CR_ROLLOUT"
			elseif player.powers[pw_carry] == CR_PTERABYTE
				v.pwcarryvar = "CR_PTERABYTE"
			else  
				v.pwcarryvar = "\x85 UNKNOWN?"
			end
			if player.powers[pw_emeralds] >= 0
				if player.powers[pw_emeralds] & EMERALD1
				v.pwemeraldsvar1 = "\x83\EMERALD1\x80|"
				else
				v.pwemeraldsvar1 = "\x86\EMERALD1\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD2
				v.pwemeraldsvar2 = "\x83\EMERALD2\x80|"
				else
				v.pwemeraldsvar2 = "\x86\EMERALD2\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD3
				v.pwemeraldsvar3 = "\x83\EMERALD3\x80|"
				else
				v.pwemeraldsvar3 = "\x86\EMERALD3\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD4
				v.pwemeraldsvar4 = "\x83\EMERALD4\x80|"
				else
				v.pwemeraldsvar4 = "\x86\EMERALD4\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD5
				v.pwemeraldsvar5 = "\x83\EMERALD5\x80|"
				else
				v.pwemeraldsvar5 = "\x86\EMERALD5\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD6
				v.pwemeraldsvar6 = "\x83\EMERALD6\x80|"
				else
				v.pwemeraldsvar6 = "\x86\EMERALD6\x80|"
				end
				if player.powers[pw_emeralds] & EMERALD7
				v.pwemeraldsvar7 = "\x83\EMERALD7\x80"
				else
				v.pwemeraldsvar7 = "\x86\EMERALD7\x80"
				end
				v.pwemeraldsvar = v.pwemeraldsvar1 .. v.pwemeraldsvar2 .. v.pwemeraldsvar3 .. v.pwemeraldsvar4 .. v.pwemeraldsvar5 .. v.pwemeraldsvar6.. v.pwemeraldsvar7
			end
			v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8D\pw_invulnerability: \x80" .. player.powers[pw_invulnerability]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8D\pw_sneakers: \x80" .. player.powers[pw_sneakers]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8D\pw_flashing: \x80" .. player.powers[pw_flashing]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8D\pw_shield: \x80" .. v.pwshieldvar .. "\x80 (\x82" .. player.powers[pw_shield] .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8D\pw_carry: \x80" .. v.pwcarryvar .. "\x80 (\x82" .. player.powers[pw_carry] .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\pw_tailsfly: \x80" .. player.powers[pw_tailsfly]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8D\pw_underwater: \x80" .. player.powers[pw_underwater]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8D\pw_spacetime: \x80" .. player.powers[pw_spacetime]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8D\pw_extralife: \x80" .. player.powers[pw_extralife]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8D\pw_pushing: \x80" .. player.powers[pw_pushing]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8D\pw_justsprung: \x80" .. player.powers[pw_justsprung]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\pw_noautobrake: \x80" .. player.powers[pw_noautobrake]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8D\pw_super: \x80" .. player.powers[pw_super]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8D\pw_gravityboots: \x80" .. player.powers[pw_gravityboots]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8D\pw_infinityring: \x80" .. player.powers[pw_infinityring]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8D\pw_automaticring: \x80" .. player.powers[pw_automaticring]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8D\pw_bouncering: \x80" .. player.powers[pw_bouncering]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\pw_scatterring: \x80" .. player.powers[pw_scatterring]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8D\pw_grenadering: \x80" .. player.powers[pw_grenadering]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8D\pw_explosionring: \x80" .. player.powers[pw_explosionring]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8D\pw_railring: \x80" .. player.powers[pw_railring]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8D\pw_emeralds: \x80" .. v.pwemeraldsvar .. "\x80 (\x82" .. player.powers[pw_emeralds] .. "\x80)"), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8D\pw_nights_superloop: \x80" .. player.powers[pw_nights_superloop]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*24)), ("\x8D\pw_nights_helper: \x80" .. player.powers[pw_nights_helper]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*25)), ("\x8D\pw_nights_linkfreeze: \x80" .. player.powers[pw_nights_linkfreeze]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*26)), ("\x8D\pw_nocontrol: \x80" .. player.powers[pw_nocontrol]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*27)), ("\x8D\pw_justlaunched: \x80" .. player.powers[pw_justlaunched]), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		elseif player.MMT.mmtTheHudStuff == 5
			v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8Dgamemap: \x80" .. tostring(gamemap)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8Dmaptol: \x80" .. tostring(maptol)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8Dultimatemode: \x80" .. tostring(ultimatemode)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8Dmariomode: \x80" .. tostring(mariomode)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8Dtwodlevel: \x80" .. tostring(twodlevel)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\circuitmap: \x80" .. tostring(circuitmap)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8Dnetgame: \x80" .. tostring(netgame)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8Dmultiplayer: \x80" .. tostring(multiplayer)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8Dmodeattacking: \x80" .. tostring(modeattacking)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8Dsplitscreen: \x80" .. tostring(splitscreen)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")			
			v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8Dgamecomplete: \x80" .. tostring(gamecomplete)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\devparm: \x80" .. tostring(devparm)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8Dmodifiedgame: \x80" .. tostring(modifiedgame)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8Dmenuactive: \x80" .. tostring(menuactive)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8Dpaused: \x80" .. tostring(paused)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8Dgametype: \x80" .. tostring(gametype)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8Dleveltime: \x80" .. tostring(leveltime)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\curWeather: \x80" .. tostring(curWeather)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8Dglobalweather: \x80" .. tostring(globalweather)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8Dlevelskynum: \x80" .. tostring(levelskynum)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")	
			v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8Dmapmusname: \x80" .. tostring(mapmusname)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8Dmapmusflags: \x80" .. tostring(mapmusflags)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8Dserver: \x80" .. tostring(server)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*24)), ("\x8D\consoleplayer: \x80" .. tostring(consoleplayer)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*25)), ("\x8D\displayplayer: \x80" .. tostring(displayplayer)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*26)), ("\x8Dsecondarydisplayplayer: \x80" .. tostring(secondarydisplayplayer)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*27)), ("\x8D\emeralds: \x80" .. tostring(emeralds)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*28)), ("\x8Dgravity: \x80" .. tostring(gravity)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*29)), ("\x8DVERSIONSTRING: \x80" .. tostring(VERSIONSTRING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*30)), ("\x8D\CODEBASE: \x80" .. tostring(CODEBASE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*31)), ("\x8D\SUBVERSION: \x80" .. tostring(SUBVERSION)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*32)), ("\x8Dtoken: \x80" .. tostring(token)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")	
		elseif player.MMT.mmtTheHudStuff == 6
			v.drawString(5, (v.InitialY+(v.YOffset*1)), ("\x8D\MF_SPECIAL: \x80" .. tostring(player.mo.flags & MF_SPECIAL)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*2)), ("\x8D\MF_SOLID: \x80" .. tostring(player.mo.flags & MF_SOLID)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*3)), ("\x8D\MF_SHOOTABLE: \x80" .. tostring(player.mo.flags & MF_SHOOTABLE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*4)), ("\x8D\MF_NOSECTOR: \x80" .. tostring(player.mo.flags & MF_NOSECTOR)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*5)), ("\x8D\MF_NOBLOCKMAP: \x80" .. tostring(player.mo.flags & MF_NOBLOCKMAP)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*6)), ("\x8D\MF_PAPERCOLLISION: \x80" .. tostring(player.mo.flags & MF_PAPERCOLLISION)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*7)), ("\x8D\MF_PUSHABLE: \x80" .. tostring(player.mo.flags & MF_PUSHABLE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*8)), ("\x8D\MF_BOSS: \x80" .. tostring(player.mo.flags & MF_BOSS)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*9)), ("\x8D\MF_SPAWNCEILING: \x80" .. tostring(player.mo.flags & MF_SPAWNCEILING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*10)), ("\x8D\MF_NOGRAVITY: \x80" .. tostring(player.mo.flags & MF_NOGRAVITY)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*11)), ("\x8D\MF_AMBIENT: \x80" .. tostring(player.mo.flags & MF_AMBIENT)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*12)), ("\x8D\MF_SLIDEME: \x80" .. tostring(player.mo.flags & MF_SLIDEME)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*13)), ("\x8D\MF_NOCLIP: \x80" .. tostring(player.mo.flags & MF_NOCLIP)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*14)), ("\x8D\MF_FLOAT: \x80" .. tostring(player.mo.flags & MF_FLOAT)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*15)), ("\x8D\MF_BOXICON: \x80" .. tostring(player.mo.flags & MF_BOXICON)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*16)), ("\x8D\MF_MISSILE: \x80" .. tostring(player.mo.flags & MF_MISSILE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*17)), ("\x8D\MF_SPRING: \x80" .. tostring(player.mo.flags & MF_SPRING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*18)), ("\x8D\MF_BOUNCE: \x80" .. tostring(player.mo.flags & MF_BOUNCE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*19)), ("\x8D\MF_MONITOR: \x80" .. tostring(player.mo.flags & MF_MONITOR)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*20)), ("\x8D\MF_NOTHINK: \x80" .. tostring(player.mo.flags & MF_NOTHINK)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*21)), ("\x8D\MF_FIRE: \x80" .. tostring(player.mo.flags & MF_FIRE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*22)), ("\x8D\MF_NOCLIPHEIGHT: \x80" .. tostring(player.mo.flags & MF_NOCLIPHEIGHT)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*23)), ("\x8D\MF_ENEMY: \x80" .. tostring(player.mo.flags & MF_ENEMY)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*24)), ("\x8D\MF_PAIN: \x80" .. tostring(player.mo.flags & MF_PAIN)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*25)), ("\x8D\MF_STICKY: \x80" .. tostring(player.mo.flags & MF_STICKY)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*26)), ("\x8D\MF_NIGHTSITEM: \x80" .. tostring(player.mo.flags & MF_NIGHTSITEM)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*27)), ("\x8D\MF_NOCLIPTHING: \x80" .. tostring(player.mo.flags & MF_NOCLIPTHING)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*28)), ("\x8D\MF_GRENADEBOUNCE: \x80" .. tostring(player.mo.flags & MF_GRENADEBOUNCE)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*29)), ("\x8D\MF_RUNSPAWNFUNC: \x80" .. tostring(player.mo.flags & MF_RUNSPAWNFUNC)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
			v.drawString(5, (v.InitialY+(v.YOffset*30)), ("\x8D\player.mo.flags: \x80" .. tostring(player.mo.flags)), V_ALLOWLOWERCASE|V_NOSCALESTART, "small")
		elseif player.MMT.mmtTheHudStuff == 0 --and mmtdebuggervar == "on"
			hud.enable("score")
			hud.enable("rings")
			hud.enable("time")
		end
	end
end

hud.add(DEBUGHUD, "game")