local function KeyToNum(key)
	if type(key) == "string" and _G["BT_"+string.upper(key)] and not (string.upper(key) == "WEAPONMASK" or string.upper(key) == "JUMP")
		return _G["BT_"+string.upper(key)]
	elseif key == "spin"
		return BT_USE
	elseif key == "ringtoss"
		return BT_ATTACK
	elseif key == "ringtossnormal"
		return BT_FIRENORMAL
	else
		return nil
	end
end

local function KeyToAmp(key) -- used specifically for amperbee's btn stuff
	if type(key) == "string"
		if key == "weaponnext"
			return "nextwep"
		elseif key == "weaponprev"
			return "prevwep"
		elseif key == "ringtoss"
			return "attack"
		elseif key == "ringtossnormal"
			return "attacknormal"
		else -- best hope it's not an invalid string, partner
			return key
		end
	else
		return nil
	end
end

local function ColorToLuaC(color) -- returns the color value used to display colors in the console, or string text in the HUD
	if (color == "white" or color == "reset")
		return "\x80"
	elseif color == "magenta"
		return "\x81"
	elseif color == "yellow"
		return "\x82"
	elseif color == "green"
		return "\x83"
	elseif color == "blue"
		return "\x84"
	elseif color == "red"
		return "\x85"
	elseif color == "gray"
		return "\x86"
	elseif color == "orange"
		return "\x87"
	elseif color == "sky"
		return "\x88"
	elseif color == "purple"
		return "\x89"
	elseif color == "aqua"
		return "\x8A"
	elseif color == "peridot"
		return "\x8B"
	elseif color == "azure"
		return "\x8C"
	elseif color == "brown"
		return "\x8D"
	elseif (color == "rosy" or color == "pink")
		return "\x8E"
	elseif color == "inverted"
		return "\x8F"
	else
		return nil
	end
end

local function numberinserver() -- thanks to "Monster ɪestyn" on the SRB2 discord for this
	local c = 0
	for p in players.iterate do c = $ + 1 end
	return c
end

local function tableremoveKey(table, key) -- src: vurdalakov on github, https://gist.github.com/vurdalakov/62ef57ef40ed01dd69a8cd9e61b16406
    local element = table[key]
    table[key] = nil
    return element
end


local function numberofskins() -- modified on code from Monster ɪestyn
	local c = 0
	for p in skins.iterate do c = $ + 1 end
	return (c-1)
end

local function numofskin(skinname)
	local c = 0
	for p in skins.iterate do 
		c = $ + 1
		if skinname == p.name
			return (c-1)
		end
	end
	return nil
end

local function tablesearch(tbl, val, case)
    for k, v in pairs(tbl) do
        if v == val then 
			return k
		elseif case == true and tostring(v) and tostring(val) and v != nil and val != nil
			if string.lower(v) == string.lower(val)
				return k
			end
		end
    end
    return nil
end

local function invtablesearch(tbl, val, case)
    for k, v in pairs(tbl) do
        if k == val then 
			return v
		elseif case == true and tostring(k) and tostring(val) and k != nil and val != nil
			if string.lower(k) == string.lower(val)
				return v
			end
		end
    end
    return nil
end

local function cmdDesc(tbl, key)
    for k, v in pairs(tbl) do
        if k == key then 
			return v
		end
    end
    return nil
end

local function changedvar(player, cmdname, var)
	CONS_Printf(player, "*\x8A " .. cmdname .. "\x80 is set to \x87" +var)
end

local function checkOnLean(onoff, togglevar)
	if onoff == "on" or onoff == "off"
		return onoff
	elseif onoff == "toggle"
		if togglevar == "on"
			return "off"
		else
			return "on"
		end
	else
		return false
	end
end

local function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

local function tableempty(self) --taken from stack overflow
    for _, _ in pairs(self) do
        return false
    end
    return true
end

local function ToggleBoo(var)
	if var == true
		return false
	else
		return true
	end
end

local function mmtdebuggerPrint(text, verbose)
	if not verbose	
		if MMTdebuggerprinting != "off"
			print(text)
		end
	else
		if MMTdebuggerprinting == "verbose"
			print(text)
		end
	end
end

local function SuperTransition(player) -- trans rights
	if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2) or (player.mo.state == S_PLAY_SUPER_TRANS3) or (player.mo.state == S_PLAY_SUPER_TRANS4) or (player.mo.state == S_PLAY_SUPER_TRANS5) or (player.mo.state == S_PLAY_SUPER_TRANS6))
		return true
	else
		return false
	end
end

local function SoupTime(player)
	if not player.waittogetdown
	and (MMTeverysuper != "disable")
	and (not (player.pflags & PF_THOKKED)) --or player.PreviousFrameThok)
	and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS)
	and not (player.pflags & PF_SHIELDABILITY)
	and not (player.pflags & PF_FINISHED)
	and not (player.pflags & PF_SPINNING)
	and (player.pflags & PF_JUMPED)
	and not SuperTransition(player)
	and player.panim != PA_ETC
	and not player.MMT.HasGlided
	and (player.playerstate == PST_LIVE)
	--and not player.UsedSpring
	--and not player.UsedTornado
	--and not player.UsedMisc
	--and not player.helduseonground 
		return true
	else
		return false
	end
end

-- Converts a Lua table to a text representation.
local function Serialize(input)
	if type(input) == "string" then
		return "[[" .. input:gsub("](%--)]", "]-%1]") .. "]]"
	elseif type(input) == "number" then
		return "[" .. input .. "]"
	elseif type(input) == "boolean" then
		if input then
			return "T"
		else
			return "F"
		end
	elseif type(input) == "nil" then
		return "N"
	elseif type(input) == "table" then

		local str = "{"
		
		local delimit = false
		for k,v in pairs(input) do
			if delimit then
				str = $ .. ";"
			end
			
			str = $ .. Serialize(k) .. ":" .. Serialize(v)
			
			delimit = true
		end
		
		str = $ .. "}"
		return str
		
	else
		error("table contains a non-serializable element!")
	end
end

-- Converts the text representation of a Lua table back to the original table.
local function Deserialize(input)
	local output

	if input:sub(1, 2) == "[[" then -- string
		local endpos = input:find("]]")
		output = input:sub(3, endpos-1):gsub("]%-(%--)]", "]%1]")
		input = $:sub(endpos+2)
	elseif input:sub(1, 1) == "[" then -- number
		local endpos = input:find("]")
		output = tonumber(input:sub(2, endpos-1))
		input = $:sub(endpos+1)
	elseif input:sub(1, 1) == "T" then -- true
		output = true
		input = $:sub(2)
	elseif input:sub(1, 1) == "F" then -- false
		output = false
		input = $:sub(2)
	elseif input:sub(1, 1) == "N" then -- nil
		output = nil
		input = $:sub(2)
	elseif input:sub(1, 2) == "{}" then -- empty table
		output = {}
		input = $:sub(3)
	elseif input:sub(1, 1) == "{" then -- table
		output = {}
		
		while input:sub(1, 1) ~= "}" do
			local key, value
			
			key, input = Deserialize(input:sub(2))
			if input:sub(1, 1) ~= ":" then
				error("string is badly formatted! "..input)
			end
			
			value, input = Deserialize(input:sub(2))
			
			output[key] = value
		end
		
		input = $:sub(2)
	else
		error("string is badly formatted! "..input)
	end
	
	if input:len() then
		return output, input
	else
		return output
	end
end

local function IsPlayerAdmin2(player)
	if IsPlayerAdmin
		return true
	elseif player == server
		return true
	else
		return false
	end
end


local function CheckReplaceSfx(mo, check, replacement, doanyways)
	if (check != replacement) and S_SoundPlaying(mo, check)
		S_StopSoundByID(mo, check)
		if replacement or doanyways S_StartSound(mo, replacement) return true end
	end
end


rawset(_G, "mmtdebuggerPrint", mmtdebuggerPrint)

rawset(_G, "MMT_KeyToNum", KeyToNum)
rawset(_G, "MMT_KeyToAmp", KeyToAmp)
rawset(_G, "MMT_numberinserver", numberinserver)
rawset(_G, "MMT_numberofskins", numberofskins)
rawset(_G, "MMT_numofskin", numofskin)
rawset(_G, "MMT_tablesearch", tablesearch)
rawset(_G, "MMT_invtablesearch", invtablesearch)
rawset(_G, "MMT_cmdDesc", cmdDesc)
rawset(_G, "MMT_checkOnLean", checkOnLean)
rawset(_G, "MMT_tablelength", tablelength)
rawset(_G, "MMT_tableempty", tableempty)
rawset(_G, "MMT_ToggleBoo", ToggleBoo)
rawset(_G, "MMT_SuperTransition", SuperTransition)
rawset(_G, "MMT_SoupTime", SoupTime)
rawset(_G, "MMT_changedvar", changedvar)
rawset(_G, "MMT_tableremoveKey", tableremoveKey)
rawset(_G, "MMT_IsPlayerAdmin", IsPlayerAdmin2)
rawset(_G, "MMT_ColorToLuaC", ColorToLuaC)
rawset(_G, "MMT_CheckReplaceSfx", CheckReplaceSfx)

rawset(_G, "MMT_Serialize", Serialize)
rawset(_G, "MMT_Deserialize", Deserialize)