--[[ Many Minor Tweaks (MMT): Revamped HUD Script
Author: birbhorse aka EeveeEuphoria


                                                                                    .   .
                                                                                  ..   ..
                                                                                ...   ...
                                                                             .............
                                                                         .................
                                                  @@@@@@@@@...............................
                                       @@@@@@@@@@@@@@@@..................................
                               @@@@@@@@@@@@@@@@@@........................................
                          @@@@@@@@@@@@@@@@@..............................................
                      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@............................
                   @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...............................
                 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......@@@@@@@@@@...................
               @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@......................
             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......................
            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...........................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@..................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....@@@...
            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....
             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....
              @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...@
               @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                               @@@@@@@@@@@@@@@@@@@@@@@
                                      @@@@@@@@@@

]]

--[[ TODO

	- [ ] secret pizza menu
		- when the player tries to scroll past the max page limit 3 times, they see a new option for a pizza at the bottom 
		- it's the order pizza command, seperate out into seperate little things to order 
		- but also keep the original command too, why not
		
	- [ ] remember cursor position when switching pages 
	
	- [ ] add an option for dividers to be displayed
		- if it's named DIVIDER, show a divider, simple 
]]

--[[MENU IDEAS

	- to logically make this function, use tables
		- tables are structured like "Fancy Name" = MMTfancyvariable
		- use _G and stuff to extract the raw variable to modify it, hopefully
			- return _G["BT_"+string.upper(key)]
		- first value is key, second value is... value 
	- make sure to have different pages, have it be seperate tables i guess /shrug
		- or do it by 10s
	
	
	- display table for each and every variable's options (on/off, all keys for superkey, etc.)

]]

-- [[[ Menu Controls ]] --
addHook("PreThinkFrame", function(thonk)
	for player in players.iterate do 
		if player.bot > 0 return end if not player.MMTHud return end if player.mo == nil return end
		pbtDaemonMMT(player)
		
		-- [[ Disable in netplay ]] --
		if netgame
			if player.MMT.MMTmenukey != nil and player.MMT.MMTmenukey != "off" 
				if player.MMTbt[MMT_KeyToAmp(player.MMT.MMTmenukey)] == 1
					CONS_Printf(player, "*\x8E WARNING:\x80 Can not use HUD in netgames! Please use \"mmtchangevar\" in the console instead!")
					--player.MMT.MenuActive = MMT_ToggleBoo($)
					return
				end
			end
		end
		
		-- [[ Normal logic starts here ]] --
		if player.MMTHud.TransBack == nil
			player.MMTHud.TransBack = 10
			player.MMTHud.OptionSelected = 1
			player.MMTHud.CurrentPage = 0
		end
		
		if (leveltime)
			player.MMTHud.VLPageLength = 0
			if player.MMTHud.LUTLength
				while (player.MMTHud.LUTLength - ((player.MMTHud.VLPageLength+1)*tonumber(player.MMT.MMTitemsperpage))) > 0 do
					player.MMTHud.VLPageLength = $ + 1
				end
			else
				while (MMTmaxoptions - ((player.MMTHud.VLPageLength+1)*tonumber(player.MMT.MMTitemsperpage))) > 0 do
					player.MMTHud.VLPageLength = $ + 1
				end
			end
			player.MMTHud.VLPageLength = $ + 1
		end
		
		if player.MMT.MenuActive
			if (leveltime % 1 == 0) and player.MMTHud.TransBack > 1
				player.MMTHud.TransBack = $ - 1
			end
		else
			if (leveltime % 2 == 0) and player.MMTHud.TransBack < 10
				player.MMTHud.TransBack = $ + 1
			end
		end
		player.MMTHud.TransFlags = player.MMTHud.TransBack<<V_ALPHASHIFT -- trans rights!
		
		-- [[ Choose Option To Change ]] --
		if player.MMT.MenuActive
			if not player.MMTHud.ChangingOption 
				-- [[ Main Menu ]] --
				player.MMTHud.MaxLength = ((player.MMTHud.CurrentPage+1)*tonumber(player.MMT.MMTitemsperpage))
				if MMTmaxoptions - player.MMTHud.MaxLength < 0
					player.MMTHud.MaxLength = $ + (MMTmaxoptions - $)
				end
				player.MMTHud.MinLength = ((player.MMTHud.CurrentPage)*tonumber(player.MMT.MMTitemsperpage))+1
				player.MMTHud.LookUpTable = nil
			else 
				-- [[ Options Menu ]] --
				local LookUp = MMT_invtablesearch(MMTVarListOptionType, player.MMTHud.ChangingOption)
				player.MMTHud.LookUpTable = _G[LookUp]
				player.MMTHud.LUTLength = MMT_tablelength(player.MMTHud.LookUpTable)
				player.MMTHud.MaxLength = ((player.MMTHud.CurrentPage+1)*tonumber(player.MMT.MMTitemsperpage))
				player.MMTHud.MinLength = ((player.MMTHud.CurrentPage)*tonumber(player.MMT.MMTitemsperpage))+1
				
				-- player.MMTHud.LUTLength is equivalent to MMTmaxoptions
				if player.MMTHud.LUTLength - player.MMTHud.MaxLength < 0
					player.MMTHud.MaxLength = $ + (player.MMTHud.LUTLength - $)
				end

				-- [ Set cursor to the current option the variable is set to ] --
				if player.MMTHud.ChangeOptionInOptionsMenu
					local ChangeCursor
					for key, value in pairs(player.MMTHud.LookUpTable) do
						if MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) -- local variable
							if key == _G[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
								ChangeCursor = value
							end
						else -- player variable
							if MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption)
								if MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption) == ""
									mmtdebuggerPrint("(pm) option to compare: " + player[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)], true)
									mmtdebuggerPrint("(pm) option set: " + key, true)
									if key == player[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
										ChangeCursor = value
									end
								else
									mmtdebuggerPrint("(pmt) option to compare: " + player[MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption)][MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)], true)
									mmtdebuggerPrint("(pmt) option set: " + key, true)
									if key == player[MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption)][MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
										ChangeCursor = value
									end
								end
							else
								mmtdebuggerPrint("(p) option to compare: " + player.MMT[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)], true)
								mmtdebuggerPrint("(p) option set: " + key, true)
								if key == player.MMT[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
									ChangeCursor = value
								end
							end
						end
					end
					if ChangeCursor
						player.MMTHud.OptionSelected = ChangeCursor
					else
						player.MMTHud.OptionSelected = 1
					end
					if MMT_tablelength(player.MMTHud.LookUpTable) > tonumber(player.MMT.MMTitemsperpage)
						if player.MMTHud.OptionSelected > tonumber(player.MMT.MMTitemsperpage)
							player.MMTHud.CurrentPage = 1
							mmtdebuggerPrint("reset page to 1 due to option being in next page")
						end
					end
					player.MMTHud.ChangeOptionInOptionsMenu = false
				end
			end
			
			-- [ Moving Cursor ] --
			if player.MMTbt.down == 1 or ((player.MMTbt.down > TICRATE/3) and (player.MMTbt.down % 2 == 0))
				player.MMTHud.OptionSelected = $ + 1
				S_StartSound(player.mo, sfx_menu1)
			end
			
			if player.MMTbt.up == 1 or ((player.MMTbt.up > TICRATE/3) and (player.MMTbt.up % 2 == 0))
				player.MMTHud.OptionSelected = $ - 1
				S_StartSound(player.mo, sfx_menu1)
			end
			
			
			-- [ Reset Cursor Position ] --
			if player.MMTHud.OptionSelected > player.MMTHud.MaxLength
				mmtdebuggerPrint("reset, >")
				player.MMTHud.OptionSelected = player.MMTHud.MinLength
			end
			
			if player.MMTHud.OptionSelected < player.MMTHud.MinLength
				mmtdebuggerPrint("reset, <")
				player.MMTHud.OptionSelected = player.MMTHud.MaxLength
			end
			
			-- [ Change Page ] --
			if player.MMTbt.right == 1 or ((player.MMTbt.right > TICRATE/3) and (player.MMTbt.right % 3 == 0))
				player.MMTHud.CurrentPage = $ + 1
				if (player.MMTHud.OptionSelected + tonumber(player.MMT.MMTitemsperpage)) < MMTmaxoptions
					player.MMTHud.OptionSelected = $ + tonumber(player.MMT.MMTitemsperpage)
				else
					player.MMTHud.OptionSelected = ($ - player.MMTHud.MinLength) + 1
					mmtdebuggerPrint("page reset cursor, right: " .. player.MMTHud.OptionSelected )
				end
				S_StartSound(player.mo, sfx_menu1)
			end
			
			if player.MMTbt.left == 1 or ((player.MMTbt.left > TICRATE/3) and (player.MMTbt.left % 3 == 0))
				player.MMTHud.CurrentPage = $ - 1
				if player.MMTHud.OptionSelected - tonumber(player.MMT.MMTitemsperpage) > 0
					player.MMTHud.OptionSelected = $ - tonumber(player.MMT.MMTitemsperpage)
				else
					if (player.MMTHud.CurrentPage) < 0
						player.MMTHud.CurrentPage = player.MMTHud.VLPageLength-1
					end
					player.MMTHud.OptionSelected = (((player.MMTHud.CurrentPage)*tonumber(player.MMT.MMTitemsperpage))+1) + $ - 1 -- can't use minlength here, because it hasn't been recalculated yet
					mmtdebuggerPrint("page reset cursor, left: " .. player.MMTHud.OptionSelected)
					if player.MMTHud.OptionSelected > MMTmaxoptions
						player.MMTHud.OptionSelected = MMTmaxoptions
						mmtdebuggerPrint("page reset cursor again, left: " .. player.MMTHud.OptionSelected)
					end
				end
				S_StartSound(player.mo, sfx_menu1)
			end
			
			
			-- [ Reset Page Position ] --
			if (player.MMTHud.CurrentPage+1) > player.MMTHud.VLPageLength 
				player.MMTHud.CurrentPage = 0
			end		
			if (player.MMTHud.CurrentPage) < 0
				player.MMTHud.CurrentPage = player.MMTHud.VLPageLength-1
			end
			
			-- [[ Change Options ]] --
			if player.MMTHud.ChangingOption and player.MMTbt.jump == 1 -- confirm new variable
				mmtdebuggerPrint("option chosen: " + MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected))
				
				local Optioneer = MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)
				local Skip = false -- used to skip going back to the main menu, solely for Misc. Options 
				mmtdebuggerPrint("Optioneer: " +Optioneer) -- MMTvariable
				
				if Optioneer == "DnD"
					if MMT_invtablesearch(MMTVarListIsSubMenu, player.MMTHud.ChangingOption) --player.MMTHud.ChangingOption == "Misc. Options"
						player.MMTHud.SubMenuOption = MMT_invtablesearch(MMTVarListNumber, MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected))
						mmtdebuggerPrint("this is a submenu")
						Skip = true
					elseif player.MMTHud.ChangingOption == "Save Settings"
						if MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected) != "no"
							MMT_SaveSettings(player)
						else
							S_StartSound(player.mo, sfx_menu1)
							player.MMT.MMTOptionChanged = true
						end
					elseif player.MMTHud.ChangingOption == "Import Old Settings"
						if MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected) != "no"
							MMT_LoadSettings(player, true)
						else
							S_StartSound(player.mo, sfx_menu1)
							player.MMT.MMTOptionChanged = true
						end
					elseif player.MMTHud.ChangingOption == "Load Settings"
						if MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected) != "no"
							MMT_LoadSettings(player)
						else
							S_StartSound(player.mo, sfx_menu1)
							player.MMT.MMTOptionChanged = true
						end
					elseif MMT_invtablesearch(MMTVarListTable, player.MMTHud.ChangingOption) -- option is a table, only used for ban skin atm, does not work with player-stored tables
						local tablevar = MMT_invtablesearch(MMTVarListTable, player.MMTHud.ChangingOption)
						mmtdebuggerPrint("table: " + tablevar)
						if MMT_invtablesearch(_G[tablevar], MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)) -- already exists, remove it from table 
							MMT_tableremoveKey(_G[tablevar], MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected))
						else -- does not exist, insert variable
							_G[tablevar][MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)] =  MMT_tablelength(_G[tablevar]) + 1
						end
						MMTbanskinNum = MMT_tablelength(MMTbanskin) + 1
						player.MMT.MMTOptionChanged = true
					end
				else
					local SaveThing
					if MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) and not MMT_invtablesearch(MMTVarListAlsoSaveLocalVar, player.MMTHud.ChangingOption)
						_G[Optioneer] = MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)
						SaveThing = "local"
					else
						if MMTVarListDifPlayerTable[player.MMTHud.ChangingOption]
							if MMTVarListDifPlayerTable[player.MMTHud.ChangingOption] == ""
								player[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)] = MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)
								mmtdebuggerPrint("player." .. MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption) .. " = " ..  MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected))
							else
								player[MMTVarListDifPlayerTable[player.MMTHud.ChangingOption]][MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)] = MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)
								mmtdebuggerPrint("player." .. MMTVarListDifPlayerTable[player.MMTHud.ChangingOption] .. "." .. MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption) .. " = " ..  MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected))
							end
							player.MMT.MMTModOptionChanged = MMT_invtablesearch(MMTVarListModSettingName, player.MMTHud.ChangingOption)
						else
							player.MMT[Optioneer] = MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)
						end
						SaveThing = "player"
						if MMT_invtablesearch(MMTVarListAlsoSaveLocalVar, player.MMTHud.ChangingOption)
							_G[Optioneer] = MMT_tablesearch(player.MMTHud.LookUpTable, player.MMTHud.OptionSelected)
							SaveThing = "player and local"
						end
					end
					if player.MMT.MMTautosave != "off" and not MMTVarListDontSave[MMT_tablesearch(MMTVarList, Optioneer)]
						MMT_SaveSpecificSetting(player, Optioneer)
						mmtdebuggerPrint("set value using the " .. SaveThing .. " variable") 
					else
						S_StartSound(player.mo, sfx_menu1)
					end
					player.MMT.MMTOptionChanged = true
				end
				
				if not Skip player.MMTHud.ForceOptionsMenuExit = true end
			end
			
			-- [[ entering options menu ]] --
			if (not player.MMTHud.ChangingOption and player.MMTbt.jump == 1) or player.MMTHud.SubMenuOption 
				if player.MMTHud.SubMenuOption
					player.MMTHud.OptionSelected = player.MMTHud.SubMenuOption
				end
				if not MMT_invtablesearch(MMTVarListIsSubMenu, player.MMTHud.ChangingOption) and not player.MMTHud.ChangingOption
					player.MMTHud.PageMemory = player.MMTHud.CurrentPage
					mmtdebuggerPrint("not a submenu, setting page memory to: " + player.MMTHud.PageMemory)
				end
				mmtdebuggerPrint(MMT_tablesearch(MMTVarListNumber, player.MMTHud.OptionSelected))
				player.MMTHud.ChangingOption = MMT_tablesearch(MMTVarListNumber, player.MMTHud.OptionSelected)		
				if MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) or MMT_invtablesearch(MMTVarListSPOnly, player.MMTHud.ChangingOption) or MMT_invtablesearch(MMTVarListMPOnly, player.MMTHud.ChangingOption)
					if (netgame and not MMT_IsPlayerAdmin(player)) or (netgame and MMT_invtablesearch(MMTVarListSPOnly, player.MMTHud.ChangingOption)) or (not multiplayer and MMT_invtablesearch(MMTVarListMPOnly, player.MMTHud.ChangingOption))
						player.MMTHud.ChangingOption = false
						S_StartSound(player.mo, sfx_menu1)
						return
					end
				end
				if not player.MMTHud.SubMenuOption player.MMTHud.MainMenuCursor = player.MMTHud.OptionSelected end
				mmtdebuggerPrint("set to: " .. player.MMTHud.MainMenuCursor)
				--player.MMTHud.OptionSelected = 1
				player.MMTHud.CurrentPage = 0 -- reset page 
				player.MMTHud.ChangeOptionInOptionsMenu = true --wow what a mouthful
				player.MMTHud.SubMenuOption = nil
				S_StartSound(player.mo, sfx_menu1)
			end
			
			-- [[ exiting options menu ]] --
			if (player.MMTHud.ChangingOption and player.MMTbt.spin == 1) or player.MMTHud.ForceOptionsMenuExit 
				if player.MMTHud.MainMenuCursor
					mmtdebuggerPrint("reset to: " .. player.MMTHud.MainMenuCursor)
					player.MMTHud.OptionSelected = player.MMTHud.MainMenuCursor
					player.MMTHud.MainMenuCursor = nil
				else
					player.MMTHud.OptionSelected = 1
				end
				player.MMTHud.ChangingOption = false
				if not player.MMTHud.ForceOptionsMenuExit
					S_StartSound(player.mo, sfx_menu1)
					mmtdebuggerPrint("forced exit to main menu")
				end
				player.MMTHud.LUTLength = nil
				player.MMTHud.ForceOptionsMenuExit = false
				if player.MMTHud.PageMemory != nil
					player.MMTHud.CurrentPage = player.MMTHud.PageMemory
					mmtdebuggerPrint("set page back to: " .. player.MMTHud.PageMemory)
					player.MMTHud.PageMemory = nil
				end
			end
		end
		
		-- [[ Activate Menu ]] --
		if player.MMT.MMTmenukey != nil and player.MMT.MMTmenukey != "off" 
			if player.MMTbt[MMT_KeyToAmp(player.MMT.MMTmenukey)] == 1
				player.MMT.MenuActive = MMT_ToggleBoo($)
				if player.MMT.MMTnagprompt == "on"
					player.MMT.MMTnagprompt = "off"
					MMT_SaveSpecificSetting(player, "MMTnagprompt", true)
				end
			end
		end
		
		-- [[ De-activate menu when player is dead ]] --
		
		if player.playerstate == PST_DEAD and player.MMT.MenuActive
			player.MMT.MenuActive = false
		end
		
		-- [[ Disable Further Input, KEEP AT BOTTOM ]] --
		if player.MMT.MenuActive
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
			player.cmd.buttons = 0
		end
	end
end)

local function MMTHud(v, player)
	v.drawScaled(0,200 , FRACUNIT*200, v.cachePatch("THEYHAVEIT"), player.MMTHud.TransFlags|V_SNAPTOLEFT|V_SNAPTOTOP) -- the dark background
	-- [[ Nag Prompt ]] -- 
	
	if player.MMT.LoadedSettings and player.MMT.MMTnagprompt == "on"
		v.drawString(158, 103, "Welcome to Many Minor Tweaks!", V_ALLOWLOWERCASE|V_30TRANS, "thin-center")
		v.drawString(158, 113, "Please press \x83" .. player.MMT.MMTmenukey .. "\x80 to open the menu!", V_ALLOWLOWERCASE|V_30TRANS, "thin-center")
	end
	
	v.CursorYOffset = ((player.MMTHud.OptionSelected - (player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage)))*10)
	
	if player.MMT.MenuActive
		if not player.MMTHud.ChangingOption -- [[ Main Menu ]] --
			v.drawString(10, 20, "\x88" .. "M" .. "\x81" .. "any " .. "\x88" .. "M" .. "\x81" .. "inor " .. "\x88" .. "T" .. "\x81" .. "weaks " .. mmtVersion .. " Menu, Page " + (player.MMTHud.CurrentPage+1), player.MMTHud.TransFlags|V_ALLOWLOWERCASE) -- main text saying name
			for key, value in pairs(MMTVarList) do
				if MMTVarListNumber[key] >= (1+(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage))) and MMTVarListNumber[key] <= (tonumber(player.MMT.MMTitemsperpage)+(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage))) -- current page number multiplier 
					if MMTVarListNumber[key] == player.MMTHud.OptionSelected
						v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTselectedtext)
					elseif ((netgame and not MMT_IsPlayerAdmin(player)) and MMTVarListLocalVar[key]) or (netgame and MMTVarListSPOnly[key]) or (not multiplayer and MMTVarListMPOnly[key]) -- local variable, or single/multi player only
						v.SpiceText = "\x86"
					else
						v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTregulartext)
					end
					local SettingToDisplay
					if value != "DnD"
						if MMT_invtablesearch(MMTVarListLocalVar, key)
							SettingToDisplay = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + _G[value]
						else
							SettingToDisplay = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + player.MMT[value]
						end
					else
						SettingToDisplay = ""
					end
					if MMT_invtablesearch(MMTVarListNumber, key) < (MMTmaxoptions+1) -- max options reached, don't display anything beyond here 
						v.drawString(40, ((MMTVarListNumber[key]+2)-(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage)))*10 , "\x87*  " + v.SpiceText + key + SettingToDisplay, player.MMTHud.TransFlags, "thin") -- place color after *, depends on if player is selecting it or not 
					end
				end
			end
		else -- [[ Options Menu ]] --
			if v.Texter == nil
				v.Texter = ""
			end
			v.drawString(10, 10, "\x88" + player.MMTHud.ChangingOption + v.Texter, player.MMTHud.TransFlags|V_ALLOWLOWERCASE) -- main text showing current option
			v.drawString(10, 20, "\x86" + MMT_invtablesearch(MMTVarListDescription, player.MMTHud.ChangingOption), player.MMTHud.TransFlags|V_ALLOWLOWERCASE, "small") -- description 
			if MMT_invtablesearch(MMTVarListDescription2, player.MMTHud.ChangingOption)
				v.drawString(10, 25, "\x86" + MMT_invtablesearch(MMTVarListDescription2, player.MMTHud.ChangingOption), player.MMTHud.TransFlags|V_ALLOWLOWERCASE, "small")
				v.Description2 = 5
			else
				v.Description2 = 0
			end
			
			-- [ Displaying The Options Available ] -- 
			if player.MMTHud.LookUpTable
				if player.MMTHud.LookUpTable
					if MMT_tablelength(player.MMTHud.LookUpTable) > tonumber(player.MMT.MMTitemsperpage)
						v.Texter = "\x81, Page " + (player.MMTHud.CurrentPage+1)
					else
						v.Texter = ""
					end
					v.CursorYOffset = $ + v.Description2
					for key, value in pairs(player.MMTHud.LookUpTable) do
						if player.MMTHud.LookUpTable[key] >= (1+(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage))) and player.MMTHud.LookUpTable[key] <= (tonumber(player.MMT.MMTitemsperpage)+(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage)))
							local XtraText = ""
							if player.MMTHud.LookUpTable[key] == player.MMTHud.OptionSelected
								v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTselectedtext)
							elseif (MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) != nil and (key == _G[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)])) 
								v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTsetoptionc)
							elseif (MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) == nil and key == player.MMT[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)])
								v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTsetoptionc)
							elseif MMT_invtablesearch(MMTVarListTable, player.MMTHud.ChangingOption) and _G[MMT_invtablesearch(MMTVarListTable, player.MMTHud.ChangingOption)][key] -- player is changing a table, and the option is turned on in table 
								v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTsetoptionc)
							elseif (MMT_invtablesearch(MMTVarListLocalVar, player.MMTHud.ChangingOption) == nil and MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption)) -- mod option menu 
								if MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption) == ""
									if key == player[MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
										v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTsetoptionc)
									else
										v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTregulartext) -- required, lest everything get upset 
									end
								else
									if key == player[MMT_invtablesearch(MMTVarListDifPlayerTable, player.MMTHud.ChangingOption)][MMT_invtablesearch(MMTVarList, player.MMTHud.ChangingOption)]
										v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTsetoptionc)
									else
										v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTregulartext)
									end
								end
							else
								v.SpiceText = MMT_ColorToLuaC(player.MMT.MMTregulartext)
							end
							if MMT_invtablesearch(MMTVarListIsSubMenu, player.MMTHud.ChangingOption) and MMTVarList[key] != "DnD"
								if MMT_invtablesearch(MMTVarListLocalVar, key)
									XtraText = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + _G[MMTVarList[key]]
								else
									if MMTVarListDifPlayerTable[key]
										if MMTVarListDifPlayerTable[key] == ""
											XtraText = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + player[MMT_invtablesearch(MMTVarList, key)]
										else
											XtraText = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + player[MMTVarListDifPlayerTable[key]][MMT_invtablesearch(MMTVarList, key)]
										end
									else
										XtraText = ": " + MMT_ColorToLuaC(player.MMT.MMTsetoptionc) + player.MMT[MMTVarList[key]]
									end
								end
							end
							v.drawString(40, (((player.MMTHud.LookUpTable[key]+2)-(player.MMTHud.CurrentPage*tonumber(player.MMT.MMTitemsperpage)))*10)+v.Description2, "\x87*  " .. v.SpiceText .. key + XtraText, player.MMTHud.TransFlags, "thin") -- place color after *, depends on if player is selecting it or not 
						end
					end
				end
			end
		end
		
		-- [ The Cursor ] --
		v.draw(33, 21+v.CursorYOffset, v.cachePatch("MMTARROW"), player.MMTHud.TransFlags)
	end
end

hud.add(MMTHud, "game")

addHook("NetVars", function(net)
	MMTeverysuper = net(MMTeverysuper)
	MMTpreserveshield = net(MMTpreserveshield)
	MMTdebuggerprinting = net(MMTdebuggerprinting)
	MMTtokentorings = net(MMTtokentorings)
	MMTclassicshields = net(MMTclassicshields)
	MMTscorecontinues = net(MMTscorecontinues)
	MMTclassicspecialstage = net(MMTclassicspecialstage)
	
	VLOT_BanSkin = net(VLOT_BanSkin)
	MMTbanskinNum = net(MMTbanskinNum)
	MMTbanskin = net(MMTbanskin)
end)


print("Many Minor Tweaks \x83" .. mmtVersion .. "\x80 loaded.") -- Use \x84mmthelp\x80 for more info on commands, or just access the commands directly for more info.