--[[ MMT Mod Support ]]--

local function AddModToMMT(modname, description, optionstable, silent)

	for key, value in pairs(MMTVarListNumber) do
		if value > MMTmaxoptions
			MMTVarListNumber[key] = (value + 1)
		end
	end

	MMTVarList[modname] = "DnD"
	MMTVarListIsSubMenu[modname] = true
	MMTVarListDescription[modname] = description

	MMTVarListOptionType[modname] = optionstable
	_G[optionstable] = {["there's nothing here..."] = 1} -- this is just so MMT doesn't spew a bunch of errors if you're trying this out for the first time
	
	MMTmaxoptions = $ + 1
	MMTsubmenustart = $ + 1
	MMTsubmenuend = $ + 1

	MMTVarListNumber[modname] = (MMTmaxoptions)
	
	if not silent print("\x83(MMT)\x8E Added\x80 mod menu for: \x82" .. modname) end
end

local function AddModSettings(modname, settingname, variable, options, description, description2, playervar, save, istable, silent)

	MMTVarList[settingname] = variable
	MMTVarListNumber[settingname] = MMT_tablelength(MMTVarListNumber) + 1

	-- find the table containing the thing in MMTVarListOptionType
	local TableFinder = MMT_invtablesearch(MMTVarListOptionType, modname)

	if MMT_invtablesearch(_G[TableFinder], "there's nothing here...")
		_G[TableFinder] = {}
	end
	
	_G[TableFinder][settingname] = (MMT_tablelength(_G[TableFinder]) + 1)

	MMTVarListModSettingName[settingname] = modname
	
	MMTVarListOptionType[settingname] = options
	if description MMTVarListDescription[settingname] = description end
	if description2 MMTVarListDescription2[settingname] = description2 end
	
	if not save
		MMTVarListDontSave[settingname] = true
	end
	if playervar
		MMTVarListDifPlayerTable[settingname] = playervar
	else
		MMTVarListLocalVar[settingname] = true 
	end
	if istable
		MMTVarListTable[settingname] = variable
		MMTVarList[settingname] = "DnD"
	end
	
	if not silent print("\x83(MMT)\x8E Added\x82 " .. settingname .. "\x80 for: \x82" .. modname) end
end

local function ModifyModParams(modname, settingname, param, variable) -- modname isn't entirely nessecary atm?
	if param == "playervar"
		if variable
			MMTVarListDifPlayerTable[settingname] = variable
			MMTVarListLocalVar[settingname] = nil
		else
			MMTVarListDifPlayerTable[settingname] = nil
		end
	elseif param == "localvar"
		if variable
			MMTVarListLocalVar[settingname] = true 
			MMTVarListDifPlayerTable[settingname] = nil
		else
			MMTVarListLocalVar[settingname] = nil
		end
	elseif param == "save"
		if variable
			MMTVarListDontSave[settingname] = nil
		else
			MMTVarListDontSave[settingname] = true
		end
	elseif param == "istable"
		if variable
			MMTVarListTable[settingname] = variable
			MMTVarList[settingname] = "DnD"
		else
			MMTVarListTable[settingname] = nil
		end
	elseif param == "playerandlocalvar"
		if variable
			MMTVarListDifPlayerTable[settingname] = variable
			MMTVarListAlsoSaveLocalVar[settingname] = true
		else
			MMTVarListAlsoSaveLocalVar[settingname] = nil
		end
	end
	mmtdebuggerPrint("\x83(MMT)\x8E Modified\x82 " .. settingname .. "\x80 parameter: \x82" .. param .. "\x80 to: \x82" + variable)
end

rawset(_G, "MMT_AddModToMMT", AddModToMMT)
rawset(_G, "MMT_AddModSettings", AddModSettings)
rawset(_G, "MMT_ModifyModParams", ModifyModParams)