--[[ mmt revamp options

this lists all the different tables for different kinds of options for various kinds of variables that need 'em
some have specific ones, others can share the tables with each other

all prefixed with VLOT_ in rawset

]]

local mmtVersion = "RVMP v4.0"

local MMTChangelog = {                                     -- try not to exceed 60 characters
["Mods can now integrate menus into MMT itself!"] = 1,
["\"SFX Style\" has been added."] = 2,
["\"Preserve Shield Between Zones\" has been added."] = 3,
["\"Recurl Multiple Times\" has been added."] = 4,
["\"Changelog\" has been added (you're looking at it now!)"] = 5,
["When the player dies, the menu now deactivates itself."] = 6,
["\"Total Rings\" now shows the difference in rings collected."] = 7,
["The custom special stage exit also applies to special stages!"] = 8,
["Replaced sfx_tokrin, reducing space on the PK3."] = 9,
["Fixed this mod breaking w/ others that use PBT3."] = 10,
["Fixed \"Recurl\" acting strangely on the ground."] = 11,
["Fixed \"Tails Ball\" letting Tails carry someone when used."] = 12,
["Fixed \"Tails Ball\" 's SFX on custom skins."] = 13,
["Fixed sub-menus resetting the current page."] = 14,
["Fixed sub-menus starting on the last page."] = 15,
["Fixed deaths being counted twice on rare occasions."] = 16,
}

-- variables --

local MMTsuperkey = "off"
local MMTsupermusic = "on"
local MMTcancelsuper = "spin"
local MMTeverysuper = "on"
local MMTtailsball = "spin"
local MMTpreserveshield = "on"
local MMTdebuggerprinting = "off"
local MMTmusicfade = "on"
local MMTsupertrail = "on"
local MMTtokentorings = "on"
local MMTsuperhover = "on"
local MMTsupershield = "on"
local MMTclassicshields = "off"
local MMTinstantrespawn = "off"
local MMTdebughud = "off"
local MMTautosave = "on"
local MMTautoload = "on"
local MMTmenukey = "custom3"
local MMTinfinitelives = "reset after level" -- this is the Deaths Counter, called infinitelives just so it can be imported from old MMT
local MMTrecurl = "off"
local MMTtotalrings = "on"
local MMTclassicsuper = "off"
local MMTitemsperpage = 10
local MMTscorecontinues = "on"
local MMTclassicspecialstage = "off"
local MMTspecialstageentrance = "on"
local MMTbanskin = {}
local MMTbanskinNum = 1
local MMTnagprompt = "on"
local MMTdcvis = "off"
local MMTselectedtext = "green"
local MMTregulartext = "orange"
local MMTsetoptionc = "yellow"
local MMTpreserveshieldzones = "off"
local MMTrecurlmulti = "off"
local MMTchangesfx = "off"

rawset(_G, "MMTsuperkey", MMTsuperkey)
rawset(_G, "MMTsupermusic", MMTsupermusic)
rawset(_G, "MMTeverysuper", MMTeverysuper)
rawset(_G, "MMTcancelsuper", MMTcancelsuper)
rawset(_G, "MMTtailsball", MMTtailsball)
rawset(_G, "MMTpreserveshield", MMTpreserveshield)
rawset(_G, "MMTdebuggerprinting", MMTdebuggerprinting)
rawset(_G, "MMTmusicfade", MMTmusicfade)
rawset(_G, "MMTsupertrail", MMTsupertrail)
rawset(_G, "MMTtokentorings", MMTtokentorings)
rawset(_G, "MMTsuperhover", MMTsuperhover)
rawset(_G, "MMTsupershield", MMTsupershield)
rawset(_G, "MMTclassicshields", MMTclassicshields)
rawset(_G, "MMTinstantrespawn", MMTinstantrespawn)
rawset(_G, "MMTdebughud", MMTdebughud)
rawset(_G, "MMTautosave", MMTautosave)
rawset(_G, "MMTautoload", MMTautoload)
rawset(_G, "MMTmenukey", MMTmenukey)
rawset(_G, "MMTinfinitelives", MMTinfinitelives)
rawset(_G, "MMTrecurl", MMTrecurl)
rawset(_G, "MMTtotalrings", MMTtotalrings)
rawset(_G, "MMTclassicsuper", MMTclassicsuper)
rawset(_G, "MMTitemsperpage", MMTitemsperpage)
rawset(_G, "MMTscorecontinues", MMTscorecontinues)
rawset(_G, "MMTclassicspecialstage", MMTclassicspecialstage)
rawset(_G, "MMTspecialstageentrance", MMTspecialstageentrance)
rawset(_G, "MMTbanskin", MMTbanskin)
rawset(_G, "MMTbanskinNum", MMTbanskinNum)
rawset(_G, "MMTnagprompt", MMTnagprompt)
rawset(_G, "MMTdcvis", MMTdcvis)
rawset(_G, "MMTselectedtext", MMTselectedtext)
rawset(_G, "MMTregulartext", MMTregulartext)
rawset(_G, "MMTsetoptionc", MMTsetoptionc)
rawset(_G, "MMTpreserveshieldzones", MMTpreserveshieldzones)
rawset(_G, "MMTrecurlmulti", MMTrecurlmulti)
rawset(_G, "MMTchangesfx", MMTchangesfx)


-- variables list --

local MMTVarList = { -- make sure each option starts with an upper-case letter, with no other-case letters afterwards (unless followed by a -, or is "MMT"), otherwise this will not work with mmtchangevar 
["Super Key"] = "MMTsuperkey",
["Super Music"] = "MMTsupermusic",
["Every Super"] = "MMTeverysuper",
["Cancel Super"] = "MMTcancelsuper",
["Tails Ball"] = "MMTtailsball",
["Preserve Shield"] = "MMTpreserveshield",
["Debug Printing"] = "MMTdebuggerprinting",
["Fade Music"] = "MMTmusicfade",
["Super Trails"] = "MMTsupertrail",
["Tokens To Rings"] = "MMTtokentorings",
["Super Hover"] = "MMTsuperhover",
["Super Shield"] = "MMTsupershield",
["Classic Shields"] = "MMTclassicshields",
["Instant Respawn"] = "MMTinstantrespawn",
["Save Settings"] = "DnD",
["Load Settings"] = "DnD",
["Import Old Settings"] = "DnD",
["Debug HUD"] = "MMTdebughud",
["MMT Autosave"] = "MMTautosave",
["MMT Autoload"] = "MMTautoload",
["MMT Menu Key"] = "MMTmenukey",
["Deaths Counter"] = "MMTinfinitelives",
["Recurl"] = "MMTrecurl",
["Total Rings"] = "MMTtotalrings",
["Classic Super"] = "MMTclassicsuper",
["Items per Page"] = "MMTitemsperpage",
["Score-Based Continues"] = "MMTscorecontinues",
["Classic Special Stage"] = "MMTclassicspecialstage",
["Ring Special Stage Entrance"] = "MMTspecialstageentrance",
["Ban Skin"] = "DnD",
["Nag Prompt"] = "MMTnagprompt",
["Misc. Options"] = "DnD",
["Deaths Counter Visibility"] = "MMTdcvis",
["Selected Text Color"] = "MMTselectedtext",
["Regular Text Color"] = "MMTregulartext",
["Set Option Color"] = "MMTsetoptionc",
["Preserve Shield Between Zones"] = "MMTpreserveshieldzones",
["Recurl Multiple Times"] = "MMTrecurlmulti",
["Changelog"] = "DnD",
["SFX Style"] = "MMTchangesfx",
}

local MMTVarListNumber = { -- what's actually displayed in the HUD menu, it's displayed in numerical order; every 10 items the menu breaks into a new page
["Super Key"] = 1,
["Cancel Super"] = 2,
["Fade Music"] = 3,
["Tails Ball"] = 4,
["Recurl"] = 5,
["SFX Style"] = 6,
["Total Rings"] = 7,
["Preserve Shield"] = 8,
["Tokens To Rings"] = 9,
["Instant Respawn"] = 10,
["Deaths Counter"] = 11,
["Score-Based Continues"] = 12,
["Classic Shields"] = 13,
["Classic Super"] = 14,
["Classic Special Stage"] = 15,
["Super Hover"] = 16,
["Super Music"] = 17,
["Super Trails"] = 18,
["Every Super"] = 19,
["Super Shield"] = 20,
["MMT Menu Key"] = 21,
["Items per Page"] = 22,
["Ban Skin"] = 23,
["Save Settings"] = 24,
["Load Settings"] = 25,
["Misc. Options"] = 26,
["Changelog"] = 27, -- MMTmaxoptions IS RIGHT HERE, UPDATE IT IF THIS NUMBER CHANGES 
["Nag Prompt"] = 28, 
["Selected Text Color"] = 29, -- SUB-MENU START
["Regular Text Color"] = 30,
["Set Option Color"] = 31,
["Ring Special Stage Entrance"] = 32,
["Deaths Counter Visibility"] = 33,
["Preserve Shield Between Zones"] = 34,
["Recurl Multiple Times"] = 35,
["MMT Autosave"] = 36,
["MMT Autoload"] = 37,
["Debug Printing"] = 38,
["Debug HUD"] = 39,
["Import Old Settings"] = 40,
}

local MMTmaxoptions = 27 -- any number beyond here will not render in the options menu 
local MMTsubmenustart = 29 -- misc. options menu items start here 
local MMTsubmenuend = 40

rawset(_G, "MMTmaxoptions", MMTmaxoptions)
rawset(_G, "MMTsubmenustart", MMTsubmenustart)
rawset(_G, "MMTsubmenuend", MMTsubmenuend)

local MMTVarListOptionType = {
["Super Key"] = "VLOT_SKButton",
["Super Music"] = "VLOT_OnOff",
["Every Super"] = "VLOT_OnOffDisable",
["Cancel Super"] = "VLOT_SKButton",
["Tails Ball"] = "VLOT_TailsBall",
["Preserve Shield"] = "VLOT_OnOff",
["Debug Printing"] = "VLOT_VOnOff",
["Fade Music"] = "VLOT_OnOff",
["Super Trails"] = "VLOT_OnOff",
["Tokens To Rings"] = "VLOT_OnOff",
["Super Hover"] = "VLOT_OnOff",
["Super Shield"] = "VLOT_OnOff",
["Classic Shields"] = "VLOT_OnOff",
["Instant Respawn"] = "VLOT_OnOff",
["Save Settings"] = "VLOT_SaveYN",
["Load Settings"] = "VLOT_SaveYN",
["Import Old Settings"] = "VLOT_SaveYN",
["Debug HUD"] = "VLOT_SKButton",
["MMT Autosave"] = "VLOT_OnOff",
["MMT Autoload"] = "VLOT_OnOff",
["MMT Menu Key"] = "VLOT_SKButton",
["Deaths Counter"] = "VLOT_DCOff",
["Recurl"] = "VLOT_Recurl",
["Total Rings"] = "VLOT_OnOff",
["Classic Super"] = "VLOT_OnOff",
["Items per Page"] = "VLOT_IpP",
["Score-Based Continues"] = "VLOT_OnOff",
["Classic Special Stage"] = "VLOT_CSS",
["Ring Special Stage Entrance"] = "VLOT_OnOff",
["Ban Skin"] = "VLOT_BanSkin",
["Nag Prompt"] = "VLOT_OnOff",
["Misc. Options"] = "VLOT_SubMenu",
["Deaths Counter Visibility"] = "VLOT_OnOff",
["Selected Text Color"] = "VLOT_Colors",
["Regular Text Color"] = "VLOT_Colors",
["Set Option Color"] = "VLOT_Colors",
["Preserve Shield Between Zones"] = "VLOT_OnOff",
["Recurl Multiple Times"] = "VLOT_OnOff",
["Changelog"] = "VLOT_ChangeLog",
["SFX Style"] = "VLOT_Sounds",
}

local MMTVarListLocalVar = { -- local variables
["Every Super"] = true,
["Preserve Shield"] = true,
["Debug Printing"] = true,
["Tokens To Rings"] = true,
["Classic Shields"] = true,
["Score-Based Continues"] = true,
["Classic Special Stage"] = true,
["Ban Skin"] = true,
}

local MMTVarListTable = { -- is variable supposed to be saved/loaded as a table? if so, point to the table variable itself. NOTE: does not work w/ player variables yet.
["Ban Skin"] = "MMTbanskin",
}

local MMTVarListSPOnly = { -- will only work in single player games 
["Score-Based Continues"] = true,
["Classic Special Stage"] = true,
["SFX Style"] = true,
}

local MMTVarListMPOnly = { -- will only work in multiplayer games 
["Ban Skin"] = true,
}

local MMTVarListIsSubMenu = {
["Misc. Options"] = true,
}

local MMTVarListDifPlayerTable = {} -- primarily used for MMT mod support 

local MMTVarListDontSave = {} -- don't save or load this variable! used for MMT mod support primarily

local MMTVarListSaveFunc = {} -- use this function to save variables, used for MMT mod support

local MMTVarListModSettingName = {} -- only used for mod support

local MMTVarListAlsoSaveLocalVar = {} -- only used for mod support



											-- ENSURE ALL DESCRIPTIONS DO NOT EXCEED THE WIDTH OF ANY GREEN RESOLUTION! recommended ammount is below 85 characters --
local MMTVarListDescription = {
["Super Key"] = "Changes the key used to go super.",
["Super Music"] = "Enables or disables music when going super.",
["Every Super"] = "Allows everyone to transform into their super form. If disabled, nobody can go super.",
["Cancel Super"] = "Binds a key to exit the character's super form.",
["Tails Ball"] = "Allows you to cancel Tails' flight into a ball.",
["Preserve Shield"] = "Preserves your shield between acts of a single zone.",
["Debug Printing"] = "Shows debug information pertaining to MMT in the console.",
["Fade Music"] = "Fades the music out when completing a stage.",
["Super Trails"] = "Creates a ghost trail behind the player when they're super.",
["Tokens To Rings"] = "If the player has all emeralds, tokens grant 50 rings instead of an extra life.",
["Super Hover"] = "Toggles the vanilla hover ability for Super Sonic.",
["Super Shield"] = "Displays the currently equipped shield while super.",
["Classic Shields"] = "Changes all the montiors in the level into shields from previous Sonic games.",
["Instant Respawn"] = "When the player dies, they are respawned instataneously.",
["Save Settings"] = "Are you sure you wish to save your settings?",
["Load Settings"] = "Are you sure you wish to load your settings?",
["Import Old Settings"] = "This imports settings from the old variant of MMT.",
["Debug HUD"] = "When used, this key will switch through various debug info; useful for devs.",
["MMT Autosave"] = "Allows MMT to automatically save settings when changing a variable.",
["MMT Autoload"] = "Allows MMT to automatically load settings when spawning the player.",
["MMT Menu Key"] = "Changes the key used to open the in-game MMT Menu.",
["Deaths Counter"] = "Replaces the player's life count with a deaths counter; you also get infinite lives.",
["Recurl"] = "Allows the player to curl back into a ball after using a spring or whirlwind.",
["Total Rings"] = "Displays the total amount of rigns in the level when pressing the scoreboard button.",
["Classic Super"] = "The player will automatically transform into their super state when jumping.",
["Items per Page"] = "Changes the amount of items viewable per page in the MMT Menu.",
["Score-Based Continues"] = "If 15,000 points are earned at the end of a level, the player gets a continue.",
["Classic Special Stage"] = "If the player ends the stage w/ 50 rings, they will be sent to a special stage.",
["Ring Special Stage Entrance"] = "If the player collects an emerald token, they will exit the stage with a new animation.",
["Ban Skin"] = "Disallows any players from selecting certain characters.",
["Nag Prompt"] = "you shouldn't be able to see this, you broke something and now i'm angry", -- >:(
["Misc. Options"] = "Miscellaneous options are found here!",
["Deaths Counter Visibility"] = "Should the deaths counter remain visible, or should it disappear after a second?",
["Selected Text Color"] = "Changes the color used for what option is currently selected!",
["Regular Text Color"] = "Changes the color used for all the items being displayed!",
["Set Option Color"] = "Changes the color used to show what option is currently set!",
["Preserve Shield Between Zones"] = "Allows \"Preserve Shield\" to continue working in-between zones.",
["Recurl Multiple Times"] = "Allows the player to recurl into a ball multiple times.",
["Changelog"] = ("The latest changes for Many Minor Tweaks " .. mmtVersion),
["SFX Style"] = "Changes various player sound effects to match other games' SFX.",
}

local MMTVarListDescription2 = { -- second line for a description; if none needed, don't provide one 
["Import Old Settings"] = "Are you sure you wish to import?",
["Every Super"] = "Setting to \"off\" assumes vanilla SRB2 behavior for handling super forms.",
["Super Shield"] = "It also displays the shield when invincible.",
["Recurl"] = "Options represent what button will be used to re-curl into a ball.",
["Deaths Counter"] = "'persistent' means the deaths counter won't be reset every new level.",
["Tails Ball"] = "\"bop\" allows you to un-curl after bopping an enemy/monitor/etc. on the head.",
["Classic Super"] = "\x82Note:\x86 Turning this on will make Super Key and Cancel Super functionless.",
["MMT Menu Key"] = "\x82Note:\x86 Can be changed using \"mmtmenukey\" in the console.",
["Score-Based Continues"] = "\x82Note:\x86 This is a bit pointless to enable with the \"Deaths Counter\" enabled.",
["Preserve Shield Between Zones"] = "\x82Note:\x86 Will not do anything if \"Preserve Shield\" is disabled.",
["Recurl Multiple Times"] = "\x82Note:\x86 Will not do anything if \"Recurl\" is disabled.",
["SFX Style"] = "\x82Note:\x86 May not play friendly with custom characters that use lua scripting!",
}
											-- ENSURE ALL DESCRIPTIONS DO NOT EXCEED THE WIDTH OF ANY GREEN RESOLUTION! recommended ammount is below 85 characters --
rawset(_G, "MMTVarList", MMTVarList)
rawset(_G, "MMTVarListNumber", MMTVarListNumber)
rawset(_G, "MMTVarListOptionType", MMTVarListOptionType)
rawset(_G, "MMTVarListLocalVar", MMTVarListLocalVar)
rawset(_G, "MMTVarListSPOnly", MMTVarListSPOnly)
rawset(_G, "MMTVarListMPOnly", MMTVarListMPOnly)
rawset(_G, "MMTVarListDescription", MMTVarListDescription)
rawset(_G, "MMTVarListDescription2", MMTVarListDescription2)
rawset(_G, "MMTVarListTable", MMTVarListTable)
rawset(_G, "MMTVarListIsSubMenu", MMTVarListIsSubMenu)
rawset(_G, "MMTVarListDontSave", MMTVarListDontSave)
rawset(_G, "MMTVarListDifPlayerTable", MMTVarListDifPlayerTable)
rawset(_G, "MMTVarListSaveFunc", MMTVarListSaveFunc)
rawset(_G, "MMTVarListModSettingName", MMTVarListModSettingName)
rawset(_G, "MMTVarListAlsoSaveLocalVar", MMTVarListAlsoSaveLocalVar)


-- [[ command descriptions ]] --

local commandDescription = {
["orderpizza"] = "*\x85 orderpizza\x80: -size \x81<value>\x80 -address \x81<value>\x80 -toppings \x81<value>\x80: order an ordinary pizza!",
["mmtmenukey"] = "*\x85 mmtmenukey\x80: \x81<key>\x80: change the key used to open the in-game HUD for MMT.",
["mmtchangevar"] = "*\x85 mmtchangevar\x80: \"\x81<option/list>\x80\" \x81<value/page>\x80: changes the value for any of the options found in the menu. If \"list\" is used, the second variable acts as the page number.",
}

rawset(_G, "MMT_commandDescription", commandDescription)

-- VLOT_* options --

-- make sure each option is lower-case all the way through, otherwise it will not work with mmtchangevar 

local SKButton = { -- off, weaponnext, weaponprev, attack/ringtoss, use/spin, camleft, camright, tossflag, firenormal/ringtossnormal, custom1, custom2, custom3
["off"] = 1,
["weaponnext"] = 2,
["weaponprev"] = 3,
["ringtoss"] = 4,
["spin"] = 5,
["camleft"] = 6,
["camright"] = 7,
["tossflag"] = 8,
["ringtossnormal"] = 9,
["custom1"] = 10,
["custom2"] = 11,
["custom3"] = 12,
}

local OnOff = {
["on"] = 1,
["off"] = 2,
}

local VOnOff = {
["verbose"] = 1,
["on"] = 2,
["off"] = 3,
}

local OnOffDisable = {
["on"] = 1,
["off"] = 2,
["disable"] = 3,
}

local TailsBall = {
["spin"] = 1,
["jump"] = 2,
["bop"] = 3,
["off"] = 4,
}

local SaveYN = {
["yes"] = 1,
["no"] = 2,
}

local Recurl = {
["jump"] = 1,
["spin"] = 2,
["off"] = 3,
}

local IpP = {
["7"] = 1,
["8"] = 2,
["9"] = 3,
["10"] = 4,
["11"] = 5,
["12"] = 6,
["13"] = 7,
["14"] = 8,
["15"] = 9,
}

local DCOff = {
["persistent"] = 1,
["reset after level"] = 2,
["off"] = 3,
}

local CSS = {
["50 rings, keep tokens"] = 1,
["50 rings, no tokens"] = 2,
--["instant warp token"] = 3,
["off"] = 3,
}

local Colors = {
["white"] = 1,
["magenta"] = 2,
["yellow"] = 3,
["green"] = 4,
["blue"] = 5,
["red"] = 6,
["gray"] = 7,
["orange"] = 8,
["sky"] = 9,
["purple"] = 10,
["aqua"] = 11,
["peridot"] = 12,
["azure"] = 13,
["brown"] = 14,
["rosy"] = 15,
["inverted"] = 16,
}

local Sounds = {
["off"] = 1,
["sonic 1"] = 2,
["sonic 2"] = 3,
["sonic cd"] = 4,
["sonic 3k"] = 5,
["knuckles' chaotix"] = 6,
["srb2"] = 7,
}

local SubMenu = {}

addHook("ThinkFrame", function()
	if (leveltime % 5) == 0
		for key, value in pairs(MMTVarListNumber) do
			if value >= MMTsubmenustart and value <= MMTsubmenuend
				SubMenu[key] = (value-MMTsubmenustart)+1
			end
		end
	end
end)

local ModMenuTableTable = {} -- used to gather options for each individual options per mod

local BanSkin = {}

addHook("ThinkFrame", function(thonk) -- MMT_numofskin
	for skin in skins.iterate do
		BanSkin[skin.name] = MMT_numofskin(skin.name)+1
	end
end)

rawset(_G, "VLOT_SKButton", SKButton)
rawset(_G, "VLOT_OnOff", OnOff)
rawset(_G, "VLOT_VOnOff", VOnOff)
rawset(_G, "VLOT_OnOffDisable", OnOffDisable)
rawset(_G, "VLOT_TailsBall", TailsBall)
rawset(_G, "VLOT_SaveYN", SaveYN)
rawset(_G, "VLOT_Recurl", Recurl)
rawset(_G, "VLOT_IpP", IpP)
rawset(_G, "VLOT_DCOff", DCOff)
rawset(_G, "VLOT_CSS", CSS)
rawset(_G, "VLOT_BanSkin", BanSkin)
rawset(_G, "VLOT_SubMenu", SubMenu)
rawset(_G, "VLOT_Colors", Colors)
rawset(_G, "VLOT_ChangeLog", MMTChangelog)
rawset(_G, "VLOT_Sounds", Sounds)

addHook("NetVars", function(net) -- NOTE: other scripts contain this, because srb2 is terrible, you gotta put this there too 
	MMTeverysuper = net(MMTeverysuper)
	MMTpreserveshield = net(MMTpreserveshield)
	MMTdebuggerprinting = net(MMTdebuggerprinting)
	MMTtokentorings = net(MMTtokentorings)
	MMTclassicshields = net(MMTclassicshields)
	MMTscorecontinues = net(MMTscorecontinues)
	MMTclassicspecialstage = net(MMTclassicspecialstage)
	
	VLOT_BanSkin = net(VLOT_BanSkin)
	MMTbanskinNum = net(MMTbanskinNum)
	MMTbanskin = net(MMTbanskin)
end)


--[[addHook("NetVars", function(net) -- this doesn't work, it causes net games to get all funky sadly
	for key, value in pairs(MMTVarList) do
		if MMTVarListLocalVar[key] -- is a local variable, needs to be set to netvar
			_G[value] = net(_G[value])
		end
	end
end)]]

rawset(_G, "mmtVersion", mmtVersion)