-- [[ MMT Lua I/O ]] --

--[[ TODO:
	- access the variables from the tables, apply it to the player
	- if not in multiplayer, don't save or apply the local variables
		- have this be the last thing the save/load settings does
	- import old settings if detected; only do it once, or by user request

	- mmtsettingsRevamp
	
]]

local MMTfolder = "mmtsettingsRevamp"
local MMTfolderOLD = "mmtsettings"

local function SaveSettings(player) -- saves all settings at the same time 
	for key, value in pairs(MMTVarList) do
		if not MMTVarListDontSave[key] -- don't save this one!
			if value != "DnD" and key != "DnD"
				if MMTVarListLocalVar[key] -- local variables, only if admin or not in a netgame 
					if not netgame --or (netgame and IsPlayerAdmin(player)) 
						if MMT_invtablesearch(MMTVarListTable, MMT_tablesearch(MMTVarList, name)) -- UNKNOWN IF THIS ACTUALLY WORKS, should save option as a table 
							local contents = MMT_Serialize(_G[name])
							mmtdebuggerPrint("(l) file name: " +name)
							mmtdebuggerPrint("(l) full file name: " .. MMTfolder .. "/" .. name .. ".dat")
							mmtdebuggerPrint("(l) contents: " + contents)
							
							local filez = io.openlocal(MMTfolder .. "/" .. name .. ".dat", "w")
							filez:write(contents)
							filez:close()
						else
							mmtdebuggerPrint("(l) file name: " +value, true)
							mmtdebuggerPrint("(l) full file name: " .. MMTfolder .. "/" .. value .. ".dat")
							mmtdebuggerPrint("(l) contents: " + _G[value], true)
							
							local filez = io.openlocal(MMTfolder .. "/" .. value .. ".dat", "w")
							filez:write(_G[value])
							filez:close()
						end
					end
				else -- assumed player variable
					mmtdebuggerPrint("(p) file name: " +value, true)
					mmtdebuggerPrint("(p) full file name: " .. "client/" .. MMTfolder .. "/" .. value .. ".dat")
					local filez2 = io.openlocal("client/" .. MMTfolder .. "/" .. value .. ".dat", "w")
					if not MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]
						mmtdebuggerPrint("(p) contents: " + player.MMT[value], true)
						filez2:write(player.MMT[value])		
					else
						if MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)] == ""
							mmtdebuggerPrint("(p) contents: " + player[value], true)
							filez2:write(player[value])
						else
							mmtdebuggerPrint("(p) contents: " + player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]][value], true)
							filez2:write(player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]][value])							
						end
					end
					filez2:close()
				end
			end
		end
	end
	CONS_Printf(player, "\x83(MMT)\x8E Saved\x80 player variable files to: \x82" .. "/client/" .. MMTfolder .. "/")
	if not netgame CONS_Printf(player, "\x83(MMT)\x8E Saved\x80 local variable files to: \x82" .. "/" .. MMTfolder .. "/") end
	--if (netgame and IsPlayerAdmin(player)) or not netgame
	S_StartSound(player.mo, sfx_addfil)
end

local function LoadSettings(player, import)
	local DidErrorHappen = false
	local Folder = MMTfolder
	local FileType = ".dat"
	if import
		Folder = MMTfolderOLD
		FileType = ".txt"
	end
	for key, value in pairs(MMTVarList) do
		if not MMTVarListDontSave[key] -- don't load this one!
			if value != "DnD" and key != "DnD"
				local VariableName = key
				if MMTVarListLocalVar[key] -- local variables, only if admin or not in a netgame 
					if (netgame and IsPlayerAdmin(player)) or not netgame
						local FileName = value
						if import
							FileName = string.sub(value, 4)
						end
						local filez = io.openlocal(Folder .. "/" .. FileName .. FileType, "r")
						if filez	
							local FilezError
							for line in filez:lines() do -- unable to do this with filez:read("*all"), for some reason it kept giving me blank strings
								if line != nil and line != ""
									local Validity = MMT_invtablesearch(MMTVarListOptionType, VariableName)
									local ValidityTable = _G[Validity]
									local ShouldIGo
									for key, value in pairs(ValidityTable) do
										if key == line
											ShouldIGo = true
										end
									end
									if ShouldIGo
										if tonumber(value) value = tonumber($) end
										if MMTVarListTable[key] -- is table, needs to be deserialized
											_G[value] = MMT_Deserialize(line)
										else
											_G[value] = line
										end
									else
										FilezError = FileName
									end
								end
							end
							mmtdebuggerPrint("(l) file name: " +FileName, true)
							mmtdebuggerPrint("(l) full file name: " .. Folder .. "/" .. value .. FileName, true)
							mmtdebuggerPrint("(l) contents: " + _G[value], true)
							-- warn player if it wasn't loaded properly
							if FilezError CONS_Printf(player, "\x85" .. "ERROR! \x82" .. FilezError .. FileType .."\x80 did not have a valid variable! Assuming default variable...") DidErrorHappen = true end
							filez:close()
						end
					end
				else -- assumed player variable
					local filez2 
					local FileName = value
					if import
						FileName = string.sub(value, 4)
					end
					if import
						filez2 = io.openlocal(Folder .. "/" .. FileName .. FileType, "r")
					else
						filez2 = io.openlocal("client/" .. Folder .. "/" .. FileName .. FileType, "r")
					end
					if filez2
						local FilezError
						for line in filez2:lines() do 
							if line != nil and line != ""
								local Validity = MMT_invtablesearch(MMTVarListOptionType, VariableName)
								local ValidityTable = _G[Validity]
								local ShouldIGo
								for key, value in pairs(ValidityTable) do
									if key == line
										ShouldIGo = true
									end
								end
								if ShouldIGo
									if tonumber(value) value = tonumber($) end
									if MMTVarListTable[key] -- is table, needs to be deserialized
										line = MMT_Deserialize(line)
									end
									if not MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]
										player.MMT[value] = line
									else
										if MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)] == ""
											player[value] = line
										else
											player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]][value] = line
										end
									end
								else
									FilezError = FileName
								end
							end
						end
						mmtdebuggerPrint("(p) file name: " +FileName, true)
						mmtdebuggerPrint("(p) full file name: " .. "client/" .. Folder .. "/" .. FileName .. FileType, true)
						if not MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]
							mmtdebuggerPrint("(p) contents: " + player.MMT[value], true)
						else
							if MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)] == ""
								mmtdebuggerPrint("(p) contents: " + player[value], true)
							else
								mmtdebuggerPrint("(p) contents: " + player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, value)]][value], true)
							end
						end
						if FilezError CONS_Printf(player, "\x85" .. "ERROR! \x82" .. FilezError .. FileType .."\x80 did not have a valid variable! Assuming default variable...") DidErrorHappen = true end
						filez2:close()
					end
				end
			end
		end
	end	
	
	if import
		CONS_Printf(player, "\x83(MMT)\x8E Imported\x80 player variable files from: \x82" .. Folder .. "/")
	else
		CONS_Printf(player, "\x83(MMT)\x8E Loaded\x80 player variable files from: \x82" .. "/client/" .. Folder .. "/")
	end
	
	if (netgame and IsPlayerAdmin(player)) or not netgame 
		if import
			CONS_Printf(player, "\x83(MMT)\x8E Imported\x80 local variable files from: \x82" .. "/" .. Folder .. "/") 
		else
			CONS_Printf(player, "\x83(MMT)\x8E Loaded\x80 local variable files from: \x82" .. "/" .. Folder .. "/") 
		end
	end
	
	if not DidErrorHappen 
		S_StartSound(player.mo, sfx_addfil)
	else
		S_StartSound(player.mo, sfx_notadd)
	end
end


local function SaveSpecificSetting(player, name, opt3) 
	if name == "DnD" return end -- just in case 
	if MMTVarListDontSave[MMT_tablesearch(MMTVarList, name)] -- don't save this one!
		return
	end
	if opt3 == "forcelocal" or (MMT_invtablesearch(MMTVarListLocalVar, MMT_tablesearch(MMTVarList, name)) != nil) -- write local variables, only if admin or not in a netgame 
		if not netgame -- (netgame and IsPlayerAdmin(player)) or not netgame
			if MMT_invtablesearch(MMTVarListTable, MMT_tablesearch(MMTVarList, name)) -- UNKNOWN IF THIS ACTUALLY WORKS, should save option as a table 
				local contents = MMT_Serialize(_G[name])
				mmtdebuggerPrint("(l) file name: " +name)
				mmtdebuggerPrint("(l) full file name: " .. MMTfolder .. "/" .. name .. ".dat")
				mmtdebuggerPrint("(l) contents: " + contents)
				
				local filez = io.openlocal(MMTfolder .. "/" .. name .. ".dat", "w")
				filez:write(contents)
				filez:close()
			else
				mmtdebuggerPrint("(l) file name: " +name)
				mmtdebuggerPrint("(l) full file name: " .. MMTfolder .. "/" .. name .. ".dat")
				mmtdebuggerPrint("(l) contents: " + _G[name])
				
				local filez = io.openlocal(MMTfolder .. "/" .. name .. ".dat", "w")
				filez:write(_G[name])
				filez:close()
			end
			CONS_Printf(player, "\x83(MMT)\x8E Saved\x80 local variable file to: \x82" .. "/" .. MMTfolder .. "/" .. name .. ".dat")
			if opt3 != true S_StartSound(player.mo, sfx_addfil) end
		end
	else -- assumed player variable
		mmtdebuggerPrint("(p) file name: " +name)
		mmtdebuggerPrint("(p) full file name: " .. "client/" .. MMTfolder .. "/" .. name .. ".dat")
		local filez2 = io.openlocal("client/" .. MMTfolder .. "/" .. name .. ".dat", "w")
		if not MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, name)]
			mmtdebuggerPrint("(p) contents: " + player.MMT[name])
			filez2:write(player.MMT[name])		
		else
			if MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, name)] == ""
				mmtdebuggerPrint("(p) contents: " + player[name])
				filez2:write(player[name])
			else
				mmtdebuggerPrint("(p) contents: " + player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, name)]][name])
				filez2:write(player[MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarList, name)]][name])
			end
		end
		filez2:close()
		CONS_Printf(player, "\x83(MMT)\x8E Saved\x80 player variable file to: \x82" .. "/client/" .. MMTfolder .. "/" .. name .. ".dat")
		if opt3 != true S_StartSound(player.mo, sfx_addfil) end
	end
end

rawset(_G, "MMT_SaveSettings", SaveSettings)
rawset(_G, "MMT_LoadSettings", LoadSettings)

rawset(_G, "MMT_SaveSpecificSetting", SaveSpecificSetting)

rawset(_G, "MMTfolder", MMTfolder)

addHook("PlayerSpawn", function(player)
	if not player.MMT.MMTLoadVars
		for i=1, MMT_tablelength(MMTVarList) do
			local Optioneer1 = MMT_tablesearch(MMTVarListNumber, i)
			local Optioneer2 = MMTVarList[Optioneer1]
			if not MMTVarListDifPlayerTable[MMT_tablesearch(MMTVarListNumber, i)] 
				player.MMT[Optioneer2] = _G[Optioneer2]
			end
		end
		player.MMT.MMTLoadVars = true
	end
end)

addHook("NetVars", function(net) -- NOTE: other scripts contain this, because srb2 is terrible, you gotta put this there too 
	MMTeverysuper = net(MMTeverysuper)
	MMTpreserveshield = net(MMTpreserveshield)
	MMTdebuggerprinting = net(MMTdebuggerprinting)
	MMTtokentorings = net(MMTtokentorings)
	MMTclassicshields = net(MMTclassicshields)
	MMTscorecontinues = net(MMTscorecontinues)
	MMTclassicspecialstage = net(MMTclassicspecialstage)
	
	VLOT_BanSkin = net(VLOT_BanSkin)
	MMTbanskinNum = net(MMTbanskinNum)
	MMTbanskin = net(MMTbanskin)
end)